# ----------------------------------------------------------------------------
# - warn-arion-network                                                       -
# - wild cruncher: arion network                                       arion -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       warn_arion_network
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Arion network

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.db.whdb_connection_point_manager import WhdbDynamicXPointDesc
from wcr_core.db_api.whdb_protocols_api import WHDB_HALIGN_CENTER
from wcr_core.modules.system.db.wphdb_connection_point_manager import \
    WphdbConnectionPointManager
from wcr_core.modules.system.db.wphdb_operator import WphdbOperator
from wplg_arion.warn_arion_connection_point import WARN_ARION_XPOINT_NAME, \
    WARN_ARION_XPOINT_CODE, WARN_XPOINT_ARN_DFLT_ARGS


WARN_ARION_NETWORK_CODE = 'wcr.arion.network'


WARN_ARION_NETWORK = WphdbOperator(
    code=WARN_ARION_NETWORK_CODE,
    xmngr=WphdbConnectionPointManager(
        xpntTypes=(WhdbDynamicXPointDesc(
            WARN_ARION_XPOINT_NAME, WARN_ARION_XPOINT_CODE,
            WARN_XPOINT_ARN_DFLT_ARGS),)),
    name='Arion Net',
    info='',
    symbol='Arion',
    labelAlign=WHDB_HALIGN_CENTER)
