# ----------------------------------------------------------------------------
# - warn-core-installer                                                      -
# - wild cruncher: core installer                               arion-plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       warn_core_installer
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core installer

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.modules.system.wpmod_connection_point_type import \
    WpmodConnectionPointType
from wplg_arion.warn_arion_connection_point import *
from wplg_arion.warn_arion_network import WARN_ARION_NETWORK
from wplg_arion.warn_distrib_service_type import \
    WARN_ARION_DISTRIBUTION_SERVICE_TYPE
from wplg_arion.warn_verifier_modules import *


def warn_core_module_install(ictx):
    """
    Install the plugin's core components.

    :param ictx: Core installation context
    :type ictx: WpplgCoreModuleInstallContextP
    """
    ictx.addDistributionServiceType(WARN_ARION_DISTRIBUTION_SERVICE_TYPE)

    ictx.addConnectionPointType(
        WpmodConnectionPointType(
            WARN_ARION_XPOINT_CODE, WARN_ARION_XPOINT_NAME,
            WARN_ARION_XPOINT_PREFIX, WarnArionXPoint,
            cfgMeta=WARN_XPOINT_ARN_CONFIG_META,
            crtnArgs=WARN_XPOINT_ARN_DFLT_ARGS))

    ictx.installOperator(WARN_ARION_NETWORK)

    ictx.addDatabaseVerifierModule(WarnXPointLeidVerifier())
    ictx.addDatabaseVerifierModule(WarnUniqueXPointLeidVerifier())
    ictx.addDatabaseVerifierModule(WarnXPointNumericLeidVerifier())
    ictx.addDatabaseVerifierModule(WarnDistribServiceSocketXPointVerifier())
    ictx.addDatabaseVerifierModule(WarnDistribServiceSocketLeidVerifier())
