# ----------------------------------------------------------------------------
# - scmn-cfg-table-record                                                    -
# - silkan python library: config table record                               -
# ----------------------------------------------------------------------------
# - author    (c) 2012-2012 amaury darsch                                    -
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------


# ----------------------------------------------------------------------------
# - record class                                                             -
# ----------------------------------------------------------------------------

class ScmnConfigTableRecord:
    def __init__(self, name, info=None, rval=None, text=None):
        """
        :param name: Record name
        :type name: str
        :param info: Record info
        :type info: str
        :param rval: Record value
        :param text: Record text
        :type text: str
        """
        #: the record name
        self.__name = name
        #: the record info
        self.__info = info
        #: the record value
        self.__rval = rval
        #: the record text
        self.__text = text

    def getName(self):
        """
        Get the record name.

        :return: the record name
        :rtype: str
        """
        return self.__name

    def getInfo(self):
        """
        Get the record info.

        :return: the record info
        :rtype: str
        """
        return self.__info

    def getValue(self):
        """
        Get the record value.

        :return: the record value
        """
        return self.__rval

    def getText(self):
        """
        Get the record text.

        :return: the record text
        :rtype: str
        """
        return self.__text
