# ----------------------------------------------------------------------------
# - wmbke-setup                                                              -
# - wild cruncher: model backend setup                       backend / model -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmbke_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Model backend setup

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_backend.actions.wbke_clean_workspace_action import \
    WBKE_CLEAN_WORKSPACE_ACTION
from wcr_backend.modules.model.actions.wmbke_build_action import \
    WMBKE_BUILD_ACTION
from wcr_backend.modules.model.actions.wmbke_compile_action import \
    WMBKE_COMPILE_ACTION
from wcr_backend.modules.model.actions.wmbke_generate_code_action import \
    WMBKE_CODE_GENERATION_ACTION
from wcr_backend.modules.model.aob.wmaob_builder import WMAOB_CODE_GENERATORS
from wcr_backend.modules.model.runtime.wmrun_execute import \
    wmrun_get_sgrun_path, wmrun_get_sgctl_path, WmrunExecutionFactory
from wcr_backend.modules.model.wmbke_install_context import \
    WmbkeModelBackendModuleInstallContextFactory
from wcr_core.action.wact_action_api import WACT_ACTION_W_DB_VERIFY, \
    WACT_ACTION_W_WS_MODIFY
from wcr_core.modules.model.actions.wmact_action_base import \
    WMACT_ACTION_W_TYPE_PROP
from wcr_core.modules.model.wmmod_application_module import \
    WMMOD_MODEL_APP_MODULE
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_core.wcor_context import wcor_registerConfigKey


WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WmbkeModelBackendModuleInstallContextFactory(WMAOB_CODE_GENERATORS))

WMMOD_MODEL_APP_MODULE.addExecutionFactory(WmrunExecutionFactory())

WMMOD_MODEL_APP_MODULE.addAction(
    WMBKE_CODE_GENERATION_ACTION, 'generate', 'wcr.backend.model',
    'backend', WACT_ACTION_W_DB_VERIFY, WMACT_ACTION_W_TYPE_PROP,
    WACT_ACTION_W_WS_MODIFY)
WMMOD_MODEL_APP_MODULE.addAction(
    WMBKE_COMPILE_ACTION, 'comp', 'wcr.backend.model', 'backend',
    WACT_ACTION_W_WS_MODIFY)
WMMOD_MODEL_APP_MODULE.addAction(
    WMBKE_BUILD_ACTION, 'build', 'wcr.backend.model', 'backend',
    WACT_ACTION_W_DB_VERIFY, WMACT_ACTION_W_TYPE_PROP,
    WACT_ACTION_W_WS_MODIFY)
WMMOD_MODEL_APP_MODULE.addAction(
    WBKE_CLEAN_WORKSPACE_ACTION, 'clean', 'wcr.backend.model', 'backend',
    WACT_ACTION_W_WS_MODIFY)

