# ----------------------------------------------------------------------------
# - wsbke-plugin-install                                                     -
# - wild cruncher: plugin install context               backend / simulation -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wsbke_plugin_install
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Plugin install context and manager

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_backend.plugin.wbke_backend_install_context import \
    WbkeBackendModuleInstallContextBase
from wcr_backend.plugin.wbke_backend_install_context_factory import \
    WbkeBackendModuleInstallContextFactoryBase
from wcr_core.modules.simulation.wsmod_application_module import \
    WSMOD_SIMULATION_APP_CODE


class WsbkeSimulationBackendModuleInstallContext(
        WbkeBackendModuleInstallContextBase):
    """
    Backend module install context.
    """

    def __init__(self, plgCode, plgName, plgDesc):
        """
        :param plgCode: Plugin code
        :type plgCode: str
        :param plgName: Plugin name
        :type plgName: str
        :param plgDesc: Plugin description
        :type plgDesc: str
        """
        super().__init__(plgCode, plgName, plgDesc)

    def commit(self):
        pass

    def installCodeGeneratorFactory(self, factory):
        raise NotImplementedError()


class WsbkeSimulationBackendModuleInstallContextFactory(
        WbkeBackendModuleInstallContextFactoryBase):
    """
    Backend module install context manager.
    """

    def getModuleCode(self):
        return WSMOD_SIMULATION_APP_CODE

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WsbkeSimulationBackendModuleInstallContext(
            plgCode, plgName, plgDesc)
