# ----------------------------------------------------------------------------
# - wsbke-setup                                                              -
# - wild cruncher: simulation backend setup             backend / simulation -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wsbke_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Simulation backend setup

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_backend.modules.simulation.actions.wsbke_generate_drs_action import \
    WSBKE_GENERATE_DRS_ACTION
from wcr_backend.modules.simulation.wsbke_install_context import \
    WsbkeSimulationBackendModuleInstallContextFactory
from wcr_core.action.wact_action_api import WACT_ACTION_W_WS_MODIFY, \
    WACT_ACTION_W_DB_VERIFY
from wcr_core.modules.simulation.wsmod_application_module import \
    WSMOD_SIMULATION_APP_MODULE
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WsbkeSimulationBackendModuleInstallContextFactory())

WSMOD_SIMULATION_APP_MODULE.addAction(
    WSBKE_GENERATE_DRS_ACTION, 'generate', 'wcr.backend.simulation',
    'backend', 'project', WACT_ACTION_W_WS_MODIFY, WACT_ACTION_W_DB_VERIFY)
