# ----------------------------------------------------------------------------
# - wpbke-plugin-install                                                     -
# - wild cruncher: plugin install context                  backend / system  -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 samuel longchamps                                -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wpbke_plugin_install
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Plugin install context and manager

.. moduleauthor:: Samuel Longchamps <samuel.longchamps@silkan.com>
"""
from wcr_backend.plugin.wbke_backend_install_context import \
    WbkeBackendModuleInstallContextBase
from wcr_backend.plugin.wbke_backend_install_context_factory import \
    WbkeBackendModuleInstallContextFactoryBase
from wcr_core.modules.system.wpmod_application_module import \
    WPMOD_SYSTEM_APP_CODE


class WpbkeSystemBackendModuleInstallContext(
        WbkeBackendModuleInstallContextBase):
    """
    Backend module install context.
    """

    def __init__(self, plgCode, plgName, plgDesc):
        """
        :param plgCode: Plugin code
        :type plgCode: str
        :param plgName: Plugin name
        :type plgName: str
        :param plgDesc: Plugin description
        :type plgDesc: str
        """
        super().__init__(plgCode, plgName, plgDesc)

    def commit(self):
        pass

    def installCodeGeneratorFactory(self, factory):
        raise NotImplementedError()


class WpbkeSystemBackendModuleInstallContextFactory(
        WbkeBackendModuleInstallContextFactoryBase):
    """
    Backend module install context manager.
    """

    def getModuleCode(self):
        return WPMOD_SYSTEM_APP_CODE

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WpbkeSystemBackendModuleInstallContext(
            plgCode, plgName, plgDesc)
