# ----------------------------------------------------------------------------
# - wbke-backend-install-context-factory                                     -
# - wild cruncher: backend install context factory          backend / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbke_backend_install_context_factory
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Backend install context factory

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_backend.plugin.wbke_backend_install_context import \
    WBKE_BACKEND_INSTALL_CODE
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgPlatformInstallContextFactoryP, WplgModuleInstallContextFactoryP, \
    WplgInstallContextFactoryP


# noinspection PyAbstractClass
class WbkeBackendInstallContextFactoryMixin(WplgInstallContextFactoryP):
    def getComponentCode(self):
        return WBKE_BACKEND_INSTALL_CODE


# noinspection PyAbstractClass
class WbkeBackendPlatformInstallContextFactoryBase(
        WplgPlatformInstallContextFactoryP,
        WbkeBackendInstallContextFactoryMixin):
    pass


# noinspection PyAbstractClass
class WbkeBackendModuleInstallContextFactoryBase(
        WplgModuleInstallContextFactoryP,
        WbkeBackendInstallContextFactoryMixin):
    pass
