# ----------------------------------------------------------------------------
# - wact-parameter-value-source-api                                          -
# - wild cruncher: parameter value source api                  core / action -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wact_parameter_value_source_api
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Parameter value source API

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import ABCMeta, abstractmethod


class WactParameterValueSourceP(metaclass=ABCMeta):

    @abstractmethod
    def getValue(self, parameter):
        """
        Get a value for the given parameter.

        :param parameter: Parameter
        :type parameter: WactActionParameterP[T]
        :return: Parameter value
        :rtype: T | None
        """
        raise NotImplementedError()
