# ----------------------------------------------------------------------------
# - wcmn-file-path                                                           -
# - wild cruncher: file path functions                         core / common -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wcmn_file_path
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher - path management

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""

# ----------------------------------------------------------------------------
# - import section                                                           -
# ----------------------------------------------------------------------------

import os

from silkan_common.scmn_file_path import scmn_path_join, scmn_mkdir


# ----------------------------------------------------------------------------
# - path functions                                                           -
# ----------------------------------------------------------------------------

def wcmn_path_data():
    """
    Get the data directory path
    """
    path = None
    # check for posix
    if os.name == 'posix':
        base = os.path.expanduser('~')
        path = scmn_path_join(base, '.silkan', 'wild-cruncher')
        # check for wonderland
    if os.name == 'nt':
        base = os.environ.get('LOCALAPPDATA')
        path = scmn_path_join(base, 'Silkan', 'Wild Cruncher')
        # make sure the directory exists
    if path:
        scmn_mkdir(path)
    return path
