# ----------------------------------------------------------------------------
# - wcmn-protocols                                                           -
# - wild cruncher: general protocols                           core / common -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wcmn_protocols
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - General protocols

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import abstractmethod, ABCMeta


class WcmnReleasableP(metaclass=ABCMeta):
    """
    Protocol for objects that have an end-of-life release function.
    """

    @abstractmethod
    def release(self):
        """
        Ask object to release references in order to prevent reference
        cycles and allow garbage collection.
        """
        pass
