# ----------------------------------------------------------------------------
# - wctl-controller-value-provider                                           -
# - wild cruncher: default controller value provider       core / controller -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wctl_controller_value_provider
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Default controller value provider

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.controller.wctl_controller_value_provider_api import \
    WctlConnectionControllerValueProviderP, \
    WctlInstanceControllerValueProviderP, WctlControllerValueProviderP
from wcr_core.db.whdb_connection_point import WHDB_DEFAULT_XPOINT_CODE
from wcr_core.dbstore_api.wdbs_connection_point_api import WDBS_XPNT_NONE


class WctlConnectionControllerValueProvider(
        WctlConnectionControllerValueProviderP):
    pass


class WctlInstanceControllerValueProvider(
        WctlInstanceControllerValueProviderP):
    def provideNewConnectionPointDirection(self, instance, **kwargs):
        return WDBS_XPNT_NONE

    def provideNewConnectionPointType(self, instance, **kwargs):
        return WHDB_DEFAULT_XPOINT_CODE


class WctlControllerValueProvider(
        WctlControllerValueProviderP,
        WctlConnectionControllerValueProvider,
        WctlInstanceControllerValueProvider):
    pass


WCTL_CONTROLLER_VALUE_PROVIDER = WctlControllerValueProvider()
