# ----------------------------------------------------------------------------
# - wdbi-protocols                                                           -
# - wild cruncher:general protocol definitions    core / dbstore / immutable -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbi_protocols
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher immutable hierarchy model protocol definitions

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import ABCMeta, abstractmethod


class WdbiWrapperMaker(metaclass=ABCMeta):
    """
    Protocol for instances that can provide wrappers for generic elements.
    """

    @abstractmethod
    def createWrapperForPath(self, path):
        """
        Get a wrapper for the element at the given path.

        :param path: Path
        :type path: list[object]
        :return: Wrapped element
        :rtype: WdbiEntityP
        """
        raise NotImplementedError()
