# ----------------------------------------------------------------------------
# - wdbm-connection-point                                                    -
# - wild cruncher:msh connection point object       core / dbstore / mutable -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbm_connection_point
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher mutable connection points

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""

from wcr_core.dbstore.mutable.wdbm_entity import WdbmTypedEntityBase
from wcr_core.dbstore_api.wdbs_connection_point_api import WdbsConnectionPointP


class WdbmConnectionPoint(WdbmTypedEntityBase, WdbsConnectionPointP):
    def __init__(self, dctx, ctyp, uuid=None, meta=None, **kwargs):
        """
        :param dctx: Database context
        :type dctx: WdbsContextP
        :param ctyp: Connection point type
        :type ctyp: str
        :param uuid: UUID
        :type uuid: UUID | str | None
        :param meta: Meta-data description
        :type meta: WdbsMetaDescriptionP | None
        :param kwargs: Additional meta-data
        """
        assert 'cdir' in kwargs

        WdbmTypedEntityBase.__init__(self, ctyp, dctx, uuid, meta, **kwargs)

        #: Connector direction (Input / Output)
        self.__direction = kwargs.get('cdir')

        #self.__connections = []
        #""":type: list[WdbmConnection]"""

    #def doDelete(self, recurse=True):
    #    connections = self.__connections
    #    self.__connections = []
    #    for conn in connections:
    #        conn.delete()
    #    super().doDelete()

    # def addConnection(self, conn):
    #     self.__connections.append(conn)
    #     self._notifyObservers(WDBS_UPDATE_CORE_EVENT)
    #
    # def removeConnection(self, conn):
    #     if self.__connections:
    #         try:
    #             self.__connections.remove(conn)
    #         except ValueError:
    #             return
    #         self._notifyObservers(WDBS_UPDATE_CORE_EVENT)

    def getDirection(self):
        return self.__direction

    def setDirection(self, direction):
        self.__direction = direction
