# ----------------------------------------------------------------------------
# - wdbm-shape                                                               -
# - wild cruncher: msh shape objects                core / dbstore / mutable -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2013-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbm_shape
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher mutable hierarchy model shapes

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.dbstore.mutable.wdbm_entity import WdbmTypedEntityBase
from wcr_core.dbstore_api.wdbs_shape_api import WdbsShapeP


class WdbmShape(WdbmTypedEntityBase, WdbsShapeP):
    def __init__(self, dctx, shapeType, uuid=None, meta=None, **kwargs):
        """
        :param dctx: Database context
        :type dctx: WdbsContextP
        :param shapeType: Shape type identifier
        :type shapeType: str
        :param uuid: UUID
        :type uuid: UUID | str | None
        :param meta: Meta-data description
        :type meta: WdbsMetaDescriptionP | None
        :param kwargs: Additional meta-data
        """
        WdbmTypedEntityBase.__init__(
            self, shapeType, dctx, uuid, meta, **kwargs)

    def __str__(self):
        return 'WdbmShape type: {} {}'.format(
            self.getEntityType(), str(self.getAllMeta()))
