# ----------------------------------------------------------------------------
# - wdbs-buttons                                                             -
# - wild cruncher:rsh interactive objects                 core / dbstore-api -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2013 clemens oertel                                   -
# - copyright (c) 2012-2013 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbs_buttons
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher raw hierarchy interactive objects

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import abstractmethod

from wcr_core.dbstore_api.wdbs_parameter_api import WdbsEntityParametersP


# noinspection PyAbstractClass
class WdbsButtonP(WdbsEntityParametersP):
    """
    Button object.
    """
    __slots__ = ()

    @abstractmethod
    def getTitle(self):
        """
        Get the button title.

        :return: Title of the button
        :rtype: str
        """
        raise NotImplementedError()

    @abstractmethod
    def setTitle(self, title):
        """
        Set the button title.

        :param title: New button title
        :type title: str
        """
        raise NotImplementedError()

    @abstractmethod
    def getCommand(self):
        """
        Get the button command.

        :return: Command associated with the button
        :rtype: str
        """
        raise NotImplementedError()

    @abstractmethod
    def setCommand(self, command):
        """
        Set the button command.

        :param command: New command for the button
        :type command: str
        """
        raise NotImplementedError()
