# ----------------------------------------------------------------------------
# - wdbs-connection-point                                                    -
# - wild cruncher:rsh connection point object             core / dbstore-api -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbs_connection_point
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher raw hierarchy connection point objects

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import abstractmethod

from wcr_core.dbstore_api.wdbs_entity_api import WdbsEntityP, WdbsTypedEntityP


#: Connection point directions
WDBS_XPNT_NONE, WDBS_XPNT_IN, WDBS_XPNT_OUT, WDBS_XPNT_BI = \
    range(0, 4)


# noinspection PyAbstractClass
class WdbsConnectionPointP(WdbsTypedEntityP, WdbsEntityP):
    """
    Connection point object.
    """

    @abstractmethod
    def getDirection(self):
        """
        Get the connection point's direction.

        :return: Direction
        :rtype: int
        """
        raise NotImplementedError()
