# ----------------------------------------------------------------------------
# - wdbs-context-api                                                         -
# - wild cruncher: DBS context                            core / dbstore-api -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbs_context_api
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - DBS context

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import ABCMeta, abstractmethod


class WdbsMetaProviderP(metaclass=ABCMeta):
    @abstractmethod
    def getMetaDescription(self, clazz, *args, **kwargs):
        """
        Get the meta-description for the given DBS class.

        :param clazz: DBS class to get meta-description for
        :type clazz: class
        :return: Meta-description for the given DBS class
        :rtype: WdbsMetaDescription
        """
        raise NotImplementedError()


# noinspection PyAbstractClass
class WdbsContextP(WdbsMetaProviderP):
    pass
