# ----------------------------------------------------------------------------
# - wdbs-model                                                               -
# - wild cruncher:rsh model object                        core / dbstore-api -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wdbs_model
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher raw hierarchy model objects

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import abstractmethod
from wcr_core.dbstore_api.wdbs_entity_api import WdbsNamedEntityP, \
    WdbsTypedEntityP


# noinspection PyAbstractClass
class WdbsModelP(WdbsNamedEntityP, WdbsTypedEntityP):
    """
    Model object.
    """

    @abstractmethod
    def getPath(self):
        """
        Get the path to the model file.

        :return: File path
        :rtype: str
        """
        raise NotImplementedError()

    @abstractmethod
    def setPath(self, path):
        """
        Set the model file path.

        :param path: New path
        :type path: str
        """
        raise NotImplementedError()

    @abstractmethod
    def getEntryPoint(self):
        """
        Get the entry point name in the model file.

        :return: Entry point name
        :rtype: str
        """
        raise NotImplementedError()

    @abstractmethod
    def setEntryPoint(self, entryPoint):
        """
        Set the entry point name in the model file.

        :param entryPoint: New entry point name
        :type entryPoint: str
        """
        raise NotImplementedError()
