# ----------------------------------------------------------------------------
# - wbhdb-standard-operators                                                 -
# - wild cruncher:standard operators                         core / bus / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbhdb_standard_operators
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher standard operators

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""
from wcr_core.db_api.whdb_protocols_api import WHDB_HALIGN_CENTER
from wcr_core.modules.bus.db.wbhdb_operator import WBHDB_OPER, WbhdbOperator
from wcr_core.modules.bus.db.wbhdb_connection_point_manager import \
    WbhdbConnectionPointManager

WBHDB_BUS_CODE = 'wcr.bus.std.bus'
WBHDB_EXT_MODULE_CODE = 'wcr.bus.std.extmod'


WBHDB_BUS = WbhdbOperator(
    code=WBHDB_BUS_CODE,
    xmngr=WbhdbConnectionPointManager(xpntTypes=None),
    name='Bus',
    info='Logical Bus',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

WBHDB_EXT_MODULE = WbhdbOperator(
    code=WBHDB_EXT_MODULE_CODE,
    xmngr=WbhdbConnectionPointManager(xpntTypes=None),
    name='ExtModule',
    info='external_module',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)


WBHDB_DEFAULT_OPS = [WBHDB_BUS, WBHDB_EXT_MODULE]

WBHDB_OPER.addOperators(WBHDB_DEFAULT_OPS)
