# ----------------------------------------------------------------------------
# - wbplg-core-install-context                                               -
# - wild cruncher: core install context                  core / bus / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbplg_core_install_context
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core install context

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""

from wcr_core.plugin.wplg_core_install_context import \
    WplgCoreModuleInstallContext, WplgCoreModuleInstallContextP
from wcr_core.plugin.wplg_core_install_context_factory import \
    WplgCoreInstallContextFactoryMixin
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgModuleInstallContextFactoryP


# noinspection PyAbstractClass
class WbplgCoreModuleInstallContextP(WplgCoreModuleInstallContextP):
    pass


class WbplgCoreModuleInstallContext(WplgCoreModuleInstallContext,
                                    WbplgCoreModuleInstallContextP):
    """
    Model core install context.
    """
    def __init__(self, plgCode, plgName, plgDesc, module):
        """
        :param module: Bus application module
        :type module: WbmodBusApplicationModuleMP
        """
        super().__init__(plgCode, plgName, plgDesc, module)



class WbpglCoreModuleInstallContextFactory(WplgModuleInstallContextFactoryP,
                                           WplgCoreInstallContextFactoryMixin):
    def __init__(self, module):
        """
        :param module: Bus application module
        :type module: WbmodBusApplicationModuleMP
        """
        self.__module = module

    def getModuleCode(self):
        return self.__module.code

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WmeplgCoreModuleInstallContext(
            plgCode, plgName, plgDesc, self.__module)
