# ----------------------------------------------------------------------------
# - wbmod-setup                                                              -
# - wild cruncher: bus setup                                      core / bus -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbmod_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Model module setup

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.modules.bus.plugin.wbplg_core_install_context import \
    WbpglCoreModuleInstallContextFactory
from wcr_core.modules.bus.wbmod_application_module import \
    WBMOD_BUS_APP_MODULE
from wcr_core.modules.wmod_application_module import wmod_registerModule
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_core.modules.bus.wbmod_distrib_service_default_types import \
    WBMOD_UDP_DISTRIBUTION_SERVICE_TYPE
from wcr_core.modules.bus.wbmod_connection_point_type import \
    WbmodConnectionPointType
from wcr_core.modules.bus.db.wbhdb_connection_points import \
    WBHDB_XPOINT_UDP_CODE, WbhdbUDPXPoint, \
    WBHDB_XPOINT_UDP_CONFIG_META, WBHDB_XPOINT_UDP_DFLT_ARGS, \
    WBHDB_XPOINT_TCP_CODE, WbhdbTCPXPoint, \
    WBHDB_XPOINT_TCP_CONFIG_META, WBHDB_XPOINT_TCP_DFLT_ARGS



# WBMOD_BUS_APP_MODULE.addDistributionServiceType(
#     WBMOD_UDP_DISTRIBUTION_SERVICE_TYPE)

WBMOD_UDP_XPOINT = WbmodConnectionPointType(
    WBHDB_XPOINT_UDP_CODE, 'UDP', 'udp', WbhdbUDPXPoint,
    cfgMeta=WBHDB_XPOINT_UDP_CONFIG_META, crtnArgs=WBHDB_XPOINT_UDP_DFLT_ARGS)

WBMOD_BUS_APP_MODULE.addConnectionPointType(WBMOD_UDP_XPOINT)

WBMOD_TCP_XPOINT = WbmodConnectionPointType(
    WBHDB_XPOINT_TCP_CODE, 'TCP', 'tcp', WbhdbTCPXPoint,
    cfgMeta=WBHDB_XPOINT_TCP_CONFIG_META, crtnArgs=WBHDB_XPOINT_TCP_DFLT_ARGS)

WBMOD_BUS_APP_MODULE.addConnectionPointType(WBMOD_TCP_XPOINT)

# wmod_registerModule(WBMOD_BUS_APP_MODULE)

# WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
#     WbpglCoreModuleInstallContextFactory(WBMOD_BUS_APP_MODULE))
