# ----------------------------------------------------------------------------
# - whhdb-Cetrac-switch-instance                                             -
# - wild cruncher: Cetrac switch instances              core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whhdb_Cetrac_switch_instance
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - PCI Card instance

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.dbstore.wdbs_meta_description import *
from wcr_core.dbstore.wdbs_meta_type import *
from wcr_core.modules.hardware.db.whhdb_standard_operators import \
    WHHDB_CETRAC_SWITCH, WHHDB_CETRAC_SWITCH_CODE
from wcr_core.db.whdb_connection_point_manager import WHDB_XPOINT_DIRECTION, \
    WHDB_XPOINT_NAME
from wcr_core.dbstore_api.wdbs_connection_point_api import WDBS_XPNT_BI
from wcr_core.modules.hardware.db.whhdb_operator_instance import \
    WhhdbOperatorInstance


class WhhdbCetracSwitchInstance(WhhdbOperatorInstance):
    """
    Operator-instance for bus instances.
    """

    def __init__(self, inst, wreg):
        """
        :param inst: Raw instance
        :type inst: WdbsOperatorInstanceP
        :param wreg: Wrapper registry
        :type wreg: WhdbWrapperRegistryP
        """
        assert inst.getOperator() == WHHDB_CETRAC_SWITCH_CODE
        WhdbOperatorInstance.__init__(self, WHHDB_CETRAC_SWITCH, inst, wreg)
        self.CARD_TO_REMOVE = []
        self.IOCARD_TO_REMOVE = []

    def _createRawConnectionPoint(self, ctyp, **kwargs):
        if WHDB_XPOINT_DIRECTION not in kwargs:
            kwargs[WHDB_XPOINT_DIRECTION] = WDBS_XPNT_BI
        return super()._createRawConnectionPoint(ctyp, **kwargs)
