# ----------------------------------------------------------------------------
# - whhdb-Host-instance-meta                                                 -
# - wild cruncher: hardware Host meta-data              core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whhdb_Host_instance_meta
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - hardware Host-instance meta-data

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.dbstore.wdbs_meta_description import *
from wcr_core.dbstore.wdbs_meta_type import *

WHHDB_CARD_NAME_KEY = 'Card_name'
WHHDB_CARD_TYPE_KEY = 'Card_type'
WHHDB_CARD_PORTS_KEY = 'Card_ports'
WHHDB_META_CTYPE_KEY = 'Card'
WHHDB_META_IOCTYPE_KEY = 'IoCard'
WHHDB_META_BIND_KEY = 'CardBind'
WHHDB_META_PTP_MASTER_KEY = 'isPtpMaster'
WHHDB_META_STATUS_KEY = 'Status'
WHHDB_META_SKEW_KEY = 'MaxSkew'

WHHDB_HOST_CARD_LIST = WdbsRecordMetaType(
    (WHHDB_CARD_TYPE_KEY, WDBS_STRING_META),
    (WHHDB_CARD_PORTS_KEY, WdbsListMetaType(WDBS_UUID_META)),
    (WHHDB_META_PTP_MASTER_KEY, WDBS_STRING_META),
    (WHHDB_META_STATUS_KEY, WDBS_STRING_META),
    (WHHDB_META_SKEW_KEY, WDBS_STRING_META),)

WHHDB_HOST_IO_LIST = WdbsRecordMetaType(
    (WHHDB_CARD_PORTS_KEY, WdbsListMetaType(WDBS_UUID_META)),
    (WHHDB_META_BIND_KEY, WDBS_STRING_META),
    )

WHHDB_HOST_META = WdbsMetaDescription(
    WhdbOperatorInstance.META,
    WdbsMetaField(WHHDB_META_CTYPE_KEY,
                  WdbsDictionaryMetaType(WDBS_STRING_META,
                                         WHHDB_HOST_CARD_LIST)),
    WdbsMetaField(WHHDB_META_IOCTYPE_KEY,
                  WdbsDictionaryMetaType(WDBS_STRING_META,
                                         WHHDB_HOST_IO_LIST))
                                )

