# ----------------------------------------------------------------------------
# - whhdb-instance-base                                                      -
# - wild cruncher:wsh instance base object              core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whhdb_instance_base
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher instance base object

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

# ----------------------------------------------------------------------------
# - import section                                                           -
# ----------------------------------------------------------------------------

from wcr_core.db.whdb_instance import WhdbInstance
from wcr_core.db_api.whdb_instance_api import WhdbInstanceP
from wcr_core.db_api.whdb_protocols_api import WhdbHasLocationP, WhdbHasFlagsP

# ----------------------------------------------------------------------------
# - instance class                                                           -
# ----------------------------------------------------------------------------

# noinspection PyAbstractClass
class WhhdbInstanceBaseP(WhdbInstanceP, WhdbHasFlagsP,
                         WhdbHasLocationP):#, WhdbHasDimensionP):

    META = WhdbInstance.META

    def __init__(self, inst, wreg):
        """
        :param inst: Raw instance
        :type inst: WdbsInstanceP
        :param wreg: Raw element wrapper registry
        :type wreg: WmhdbWrapperRegistry
        """
        self.__rawInstance = inst
        self.__wrapperRegistry = wreg

    def getConnectionPointDescription(self, conn, **kwargs):
        return conn.getDescription(**kwargs)

    def getConnectorByName(self, name):
        # noinspection PyUnresolvedReferences
        return next((c for c in self.getConnectionPoints()
                     if c.getName() == name), None)

    def getConnectorByPortRef(self, ref):
        # noinspection PyUnresolvedReferences
        return next((c for c in self.getConnectionPoints()
                     if c.getPortReference() == ref), None)
