# ----------------------------------------------------------------------------
# - whhdb-Rack-instance-meta                                                 -
# - wild cruncher: hardware Rack meta-data              core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2017-2017 achraf mahti                                     -
# - copyright (c) 2017-2017 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whhdb_Rack_instance_meta
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - hardware Host-instance meta-data

.. moduleauthor:: Achraf Mahti <mahti@silkan.net>
"""

from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.dbstore.wdbs_meta_description import *
from wcr_core.dbstore.wdbs_meta_type import *

WHHDB_MAX_CARD = 11
WHHDB_IO_CARD_LIBRARY = 'wcr.ioc'
WHHDB_CARD_NAME_KEY = 'Card_name'
WHHDB_CARD_TYPE_KEY = 'Card_type'
WHHDB_CARD_PORTS_KEY = 'Card_ports'
WHHDB_META_CTYPE_KEY = 'Card'
WHHDB_CARD_POSITION_KEY = 'Position'
WHHDB_META_REPORT_STATUS_KEY = 'reportStatus'

WHHDB_RACK_CARD_LIST = WdbsRecordMetaType(
    (WHHDB_CARD_NAME_KEY, WDBS_STRING_META),
    (WHHDB_CARD_TYPE_KEY, WDBS_STRING_META),
    (WHHDB_CARD_POSITION_KEY, WDBS_STRING_META),
    (WHHDB_CARD_PORTS_KEY, WdbsListMetaType(WDBS_UUID_META)),
    (WHHDB_META_REPORT_STATUS_KEY, WDBS_STRING_META),
)

WHHDB_IOCARD_META = WdbsMetaDescription(
    WhdbOperatorInstance.META,
    WdbsMetaField(WHHDB_META_CTYPE_KEY,
                  WHHDB_RACK_CARD_LIST))

WHHDB_IOCARD_POWER_SUPPLY = 'power_supply'
WHHDB_IOCARD_DIS16IN_LOW = 'dis16in_lowv'
WHHDB_IOCARD_DIS32IN_LOW = 'dis32in_lowv'
WHHDB_IOCARD_DIS16IN_HI = 'dis16in_hiv'
WHHDB_IOCARD_DIS32IN_HI = 'dis32in_hiv'
WHHDB_IOCARD_DIS16IN_HI_LOW = 'dis16in_hi_lowv'
WHHDB_IOCARD_DIS32IN_HI_LOW = 'dis32in_hi_lowv'
WHHDB_IOCARD_DIS16IN_HI_HI = 'dis16in_hi_hiv'
WHHDB_IOCARD_DIS32IN_HI_HI = 'dis32in_hi_hiv'
WHHDB_IOCARD_DIS32OUT_HIV_P = 'dis32in_hiv_p'
WHHDB_IOCARD_DIS16OUT_RELAY = 'dis16out_relay'
WHHDB_IOCARD_DIS8OUT_RELAY = 'dis8out_relay'
WHHDB_IOCARD_ANA8IN = 'ana8in'
WHHDB_IOCARD_ANA8IN_E = 'ana8in_e'
WHHDB_IOCARD_ANA8OUT = 'ana8out'
WHHDB_IOCARD_ANA8OUT_E = 'ana8out_e'
WHHDB_IOCARD_FREQ4OUT = 'freq4out'
WHHDB_IOCARD_PWM4OUT = 'pwm4out'
WHHDB_IOCARD_PWM8IN = 'pwm8in'
WHHDB_IOCARD_XVDT4OUT = 'xvdt3out'
WHHDB_IOCARD_CARRIER429ASYNC_8IO = 'carrier_429async_8io'
WHHDB_IOCARD_PPTC8IN = 'pttc8in'
WHHDB_IOCARD_FREQ12in = 'freq12in'
WHHDB_IOCARD_CAN8IO = 'can8io'
WHHDB_IOCARD_ANA8IN_14B = 'ana8in_14b'
WHHDB_IOCARD_ANA8OUT_16B = 'ana8out_16b'
WHHDB_IOCARD_RS8IO = 'rs8io'

IO_TYPES = [WHHDB_IOCARD_DIS16IN_LOW, WHHDB_IOCARD_DIS32IN_LOW,
            WHHDB_IOCARD_DIS16IN_HI, WHHDB_IOCARD_DIS32IN_HI,
            WHHDB_IOCARD_DIS16IN_HI_LOW, WHHDB_IOCARD_DIS32IN_HI_LOW,
            WHHDB_IOCARD_DIS16IN_HI_HI, WHHDB_IOCARD_DIS32IN_HI_HI,
            WHHDB_IOCARD_DIS32OUT_HIV_P, WHHDB_IOCARD_DIS16OUT_RELAY,
            WHHDB_IOCARD_DIS8OUT_RELAY, WHHDB_IOCARD_ANA8IN,
            WHHDB_IOCARD_ANA8IN_E, WHHDB_IOCARD_ANA8OUT,
            WHHDB_IOCARD_ANA8OUT_E, WHHDB_IOCARD_FREQ4OUT,
            WHHDB_IOCARD_PWM4OUT, WHHDB_IOCARD_PWM8IN,
            WHHDB_IOCARD_XVDT4OUT, WHHDB_IOCARD_POWER_SUPPLY,
            WHHDB_IOCARD_CARRIER429ASYNC_8IO, WHHDB_IOCARD_PPTC8IN,
            WHHDB_IOCARD_FREQ12in, WHHDB_IOCARD_CAN8IO,
            WHHDB_IOCARD_ANA8IN_14B, WHHDB_IOCARD_ANA8OUT_16B,
            WHHDB_IOCARD_RS8IO]