# ----------------------------------------------------------------------------
# - whhdb-top-block                                                          -
# - wild cruncher:wsh top hierarchy object              core / hardware / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 lambert philippe                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmehdb_top_block
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher top hierarchy object

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.modules.hardware.db.whhdb_block import WhhdbBlock


class WhhdbTopHierarchy(WhhdbBlock):
    """
    The WmhdbTopHierarchy is the top hierarchy model class. A top hierarchy
    is at the same time a model and an instance. The class provides several
    methods for creating the hierarchy.
    """
    META = WhhdbBlock.META

    def __init__(self, block, wreg):
        """
        :param block: Raw block
        :type block: WdbsBlockP
        :param wreg: Wrapper registry
        :type wreg: WmhdbWrapperRegistry
        """
        super().__init__(block, wreg)

    def checkportIsConnected(self, portUuid):
        """
            check if the given port is connected
            :param pportuuid: uuid of the physical port
            :type pportuuid: uuid
            :return True is the portUuid is found inn the connected ports list
            :rtype boolean
        """
        isConnected = False
        for conn in self.getConnections():
            portEnd = conn.getEndConnectionPoint()
            portStart = conn.getStartConnectionPoint()
            if portUuid == portEnd.getUUID() or portUuid ==portStart.getUUID():
                isConnected = True
        return isConnected