# ----------------------------------------------------------------------------
# - whplg-core-install-context                                               -
# - wild cruncher: core install context             core / hardware / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whplg_core_install_context
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core install context

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""

from wcr_core.plugin.wplg_core_install_context import \
    WplgCoreModuleInstallContext, WplgCoreModuleInstallContextP
from wcr_core.plugin.wplg_core_install_context_factory import \
    WplgCoreInstallContextFactoryMixin
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgModuleInstallContextFactoryP
from wcr_core.modules.hardware.plugin.whplg_library_reader import \
    whplg_read_operator


# noinspection PyAbstractClass
class WhplgCoreModuleInstallContextP(WplgCoreModuleInstallContextP):
    pass


class WhplgCoreModuleInstallContext(WplgCoreModuleInstallContext,
                                    WhplgCoreModuleInstallContextP):
    """
    Model core install context.
    """
    def __init__(self, plgCode, plgName, plgDesc, module):
        """
        :param module: Message application module
        :type module: WmemodMessageApplicationModuleMP
        """
        super().__init__(plgCode, plgName, plgDesc, module)

    def installOperatorFile(self, file, libCode=None):
        operator = whplg_read_operator(file, libCode)
        self.installOperator(operator)


class WhpglCoreModuleInstallContextFactory(
        WplgModuleInstallContextFactoryP,
        WplgCoreInstallContextFactoryMixin):
    def __init__(self, module):
        """
        :param module: Model application module
        :type module: WmmodModelApplicationModuleMP
        """
        self.__module = module

    def getModuleCode(self):
        return self.__module.code

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WhplgCoreModuleInstallContext(
            plgCode, plgName, plgDesc, self.__module)
