# ----------------------------------------------------------------------------
# - whmod-setup                                                              -
# - wild cruncher: hardware setup                            core / hardware -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whmod_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Model module setup

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.modules.hardware.plugin.whplg_core_install_context import \
    WhpglCoreModuleInstallContextFactory
from wcr_core.modules.hardware.whmod_application_module import \
    WHMOD_HARDWARE_APP_MODULE
from wcr_core.modules.wmod_application_module import wmod_registerModule
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_core.modules.hardware.whmod_connection_point_type import \
    WhmodConnectionPointType
from wcr_core.modules.hardware.db.whhdb_connection_points import *

# add connectors of all protocol to the module
for xpntType in (WHHDB_XPOINT_NAMES + WHHDB_MODULES_IO_NAMES):
    XPOINT = WhmodConnectionPointType(xpntType, 'Default',
                                      'def', WhhdbHardwareXPoint,
                                      cfgMeta=WHHDB_XPOINT_CONFIG_META,
                                      cfgDisMeta=WHHDB_XPOINT_CONFIG_DIS_META,
                                      cfgFiberMeta=WHHDB_XPOINT_CONFIG_FB_META,
                                      cfgAfdxMeta=WHHDB_XPOINT_CONFIG_AFDX_META,
                                      cfg1553Meta=WHHDB_XPOINT_CONFIG_1553_META,
                                      cfgARINC825Meta=WHHDB_XPOINT_CONFIG_ARINC825_META,
                                      crtnArgs=WHHDB_XPOINT_DFLT_ARGS)
    WHMOD_HARDWARE_APP_MODULE.addConnectionPointType(XPOINT)


wmod_registerModule(WHMOD_HARDWARE_APP_MODULE)

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WhpglCoreModuleInstallContextFactory(WHMOD_HARDWARE_APP_MODULE))
