# ----------------------------------------------------------------------------
# - wihdb-meta-provider                                                      -
# - wild cruncher: meta-data provider                        core / icd / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wihdb_meta_provider
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy meta-data provider

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_meta_provider import WhdbMetaProvider
from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.modules.icd.db.wihdb_standard_operators import WIHDB_MODULE_CODE
from wcr_core.modules.icd.db.wihdb_module_instance import WihdbModuleInstance

WIHDB_STD_OPERINST_META = {WIHDB_MODULE_CODE: WihdbModuleInstance.META}
"""{OPERATOR_CODE: META}"""
IMPORTED_MODULE_CODE = 'wcr.icd.module'


class WihdbMetaProvider(WhdbMetaProvider):
    def __init__(self, blockMetas):
        super().__init__()
        self.__blockMetas = blockMetas

    def getBlockMeta(self, btyp=None):
        if btyp:
            meta = self.__blockMetas.get(btyp)
            if meta:
                return meta
        return WihdbBlock.META

    def getOperatorInstanceMeta(self, oper=None):
        opMeta = WIHDB_STD_OPERINST_META.get(oper)
        if opMeta is not None:
            return opMeta
        elif IMPORTED_MODULE_CODE in oper:
            return WihdbModuleInstance.META
        else:
            return WhdbOperatorInstance.META
