# ----------------------------------------------------------------------------
# - wihdb-standard-operators                                                 -
# - wild cruncher:standard operators                         core / icd / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wihdb_standard_operators
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher standard operators

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.modules.icd.db.wihdb_operator import WIHDB_OPER, WihdbOperator
from wcr_core.db_api.whdb_protocols_api import WHDB_HALIGN_LEFT, \
    WHDB_HALIGN_RIGHT
from wcr_core.modules.icd.db.wihdb_connection_point_manager import \
    WihdbConnectionPointManager


WIHDB_MODULE_CODE = 'wcr.icd.std.modules'
WIHDB_WBMESSAGE_CODE = 'wcr.icd.std.wbmessage'


WIHDB_WBMESSAGE = WihdbOperator(
    code=WIHDB_WBMESSAGE_CODE,
    xmngr=None,
    name='Wight Box Message',
    info='Wight Box Message',
    symbol='',
    labelAlign=WHDB_HALIGN_LEFT)

WIHDB_MODULE = WihdbOperator(
    code=WIHDB_MODULE_CODE,
    xmngr=WihdbConnectionPointManager(xpntTypes=None),
    name='Module',
    info='Module',
    symbol='',
    labelAlign=WHDB_HALIGN_LEFT)

WIHDB_OPS = [WIHDB_MODULE, WIHDB_WBMESSAGE]

# WIHDB_OPER.addOperators(WIHDB_OPS)
