# ----------------------------------------------------------------------------
# - wihdb-top-block-meta                                                     -
# - wild cruncher: icd top block meta-data                   core / icd / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wihdb_top_block_meta
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - icd Top Block meta-data

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""
from wcr_core.modules.icd.db.wihdb_block import WihdbBlock
from wcr_core.dbstore.wdbs_meta_description import *
from wcr_core.dbstore.wdbs_meta_type import *


WIHDB_META_GLOBAL_MESSAGES_KEY = "global_messages"
WIHDB_META_GLOBAL_TYPES_KEY = "global_types"
WIHDB_META_MESSAGES_BINDING_KEY = "messages_binding"


WIHDB_ICD_GLOBAL_DICTIONNARY = WdbsMetaDescription(
    WihdbBlock.META,
    WdbsMetaField(
        WIHDB_META_GLOBAL_TYPES_KEY,
        WdbsListMetaType(WdbsTupleMetaType(WDBS_STRING_META,
                                           WdbsListMetaType(
                                               WDBS_STRING_META)))),
    WdbsMetaField(
        WIHDB_META_GLOBAL_MESSAGES_KEY,
        WdbsDictionaryMetaType(WDBS_STRING_META,
                               WdbsTupleMetaType(WDBS_STRING_META,
                                                 WDBS_STRING_META))),

    WdbsMetaField(
        WIHDB_META_MESSAGES_BINDING_KEY,
        WdbsDictionaryMetaType(WDBS_STRING_META,
                               WdbsListMetaType(
                                   WdbsTupleMetaType(WDBS_STRING_META,
                                                     WDBS_STRING_META)))),
)