# ----------------------------------------------------------------------------
# - wiplg-core-install-context                                               -
# - wild cruncher: core install context                  core / icd / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wiplg_core_install_context
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core install context

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""

from wcr_core.plugin.wplg_core_install_context import \
    WplgCoreModuleInstallContext, WplgCoreModuleInstallContextP
from wcr_core.plugin.wplg_core_install_context_factory import \
    WplgCoreInstallContextFactoryMixin
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgModuleInstallContextFactoryP


# noinspection PyAbstractClass
class WiplgCoreModuleInstallContextP(WplgCoreModuleInstallContextP):
    pass


class WiplgCoreModuleInstallContext(WplgCoreModuleInstallContext,
                                    WiplgCoreModuleInstallContextP):
    """
    Model core install context.
    """
    def __init__(self, plgCode, plgName, plgDesc, module):
        """
        :param module: ICD application module
        :type module: WmemodMessageApplicationModuleMP
        """
        super().__init__(plgCode, plgName, plgDesc, module)



class WipglCoreModuleInstallContextFactory(
        WplgModuleInstallContextFactoryP,
        WplgCoreInstallContextFactoryMixin):
    def __init__(self, module):
        """
        :param module: Model application module
        :type module: WimodModelApplicationModuleMP
        """
        self.__module = module

    def getModuleCode(self):
        return self.__module.code

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WiplgCoreModuleInstallContext(
            plgCode, plgName, plgDesc, self.__module)
