# ----------------------------------------------------------------------------
# - wmeact-action-base                                                       -
# - wild cruncher: message action base              core / message / actions -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmeact_action_base
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Simulation base action

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""

from wcr_core.action.wact_action import WactActionBase


# noinspection PyAbstractClass
class WmeactActionBase(WactActionBase):
    def __init__(self, name, description, *parameters):
        """
        :param name: Action name
        :type name: str
        :param description: Action description
        :type description: str
        :param parameters: Action parameter descriptions
        :type parameters: list[WactActionParameterP]
        """
        super().__init__(name, description, *parameters)

    def isEnabled(self, actx):
        """
        :type actx: WactActionExecutionContextP
        """
        if not super().isEnabled(actx):
            return False
        pctx = actx.getProjectContext()
        return bool(pctx) and pctx.getModule().code == 'message'
