# ----------------------------------------------------------------------------
# - wmehdb-instance-base                                                     -
# - wild cruncher:wsh instance base object               core / message / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmehdb_instance_base
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher instance base object

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

# ----------------------------------------------------------------------------
# - import section                                                           -
# ----------------------------------------------------------------------------

from wcr_core.db.whdb_instance import WhdbInstance
from wcr_core.db_api.whdb_instance_api import WhdbInstanceP
from wcr_core.db_api.whdb_protocols_api import WhdbHasLocationP, WhdbHasFlagsP
from wcr_core.dbstore.wdbs_meta_description import WdbsMetaDescription, \
    WdbsMetaField

# ----------------------------------------------------------------------------
# - instance class                                                           -
# ----------------------------------------------------------------------------

# noinspection PyAbstractClass
class WmhdbInstanceBaseP(WhdbInstanceP, WhdbHasFlagsP,
                         WhdbHasLocationP, WhdbHasDimensionP):
    META = WdbsMetaDescription(
        WhdbInstance.META)

    def __init__(self, inst, wreg):
        """
        :param inst: Raw instance
        :type inst: WdbsInstanceP
        :param wreg: Raw element wrapper registry
        :type wreg: WmhdbWrapperRegistry
        """
        self.__rawInstance = inst
        self.__wrapperRegistry = wreg
