# ----------------------------------------------------------------------------
# - wmehdb-verifier                                                          -
# - wild cruncher:hierarchy verifier                     core / message / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmehdb_verifier
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher hierarchy verifier

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""
from wcr_core.db.whdb_verifier import WhdbVerifierModuleP, \
    WhdbHierarchyVerifier


#: List of all hierarchy verification modules to be enabled by default
WMEHDB_VRFYM = []

class WmehdbHierarchyVerifier(WhdbHierarchyVerifier):
    """
    Message hierarchy verifier.
    """

    def __init__(self, modules=None):
        """
        :param modules: Additional verification modules to use.
        :type modules: Iterable[WhdbVerifierModuleP] | None
        """
        if modules:
            mods = list(WMEHDB_VRFYM)
            mods.extend(modules)
        else:
            mods = WMEHDB_VRFYM

        super().__init__(mods)
