# ----------------------------------------------------------------------------
# - wmemod-project-context                                                   -
# - wild cruncher - message project context                core / simulation -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmemod_project_context
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher Message project context

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.project.wprj_project_context import WprjProjectContext
from wcr_core.modules.message.controller.wmectl_controllers import \
    WmectlControllerFactory



class WmemodMessageProjectContext(WprjProjectContext):
    """
    Default project context implementation.
    """

    def __init__(self, gContext, module, projectDB, logger):
        """
        :param gContext: Global context
        :type gContext: WcorGlobalContextP
        :param module: Application module
        :type module: WmodApplicationModuleP
        :param projectDB: Project database
        :type projectDB: WprjProjectDatabase
        :param logger: Logger
        :type logger: ScmnLoggerP
        """
        super().__init__(gContext, module, projectDB, logger)

        projectDB.getTopHierarchy().setSourcePath(projectDB.path)

        self.__ctrlFy = WmectlControllerFactory()

    def getControllerFactory(self):
        return self.__ctrlFy