# ----------------------------------------------------------------------------
# - wmhdb-block-proxy                                                        -
# - wild cruncher:wsh model block proxy                    core / model / db -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2013 clemens oertel                                   -
# - copyright (c) 2013-2013 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmhdb_block_proxy
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy model block proxy

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.db.whdb_block_proxy import WhdbHierarchyBlockProxy
from wcr_core.modules.model.db.wmhdb_block_base import WmhdbBlockP


class WmhdbBlockProxy(WhdbHierarchyBlockProxy, WmhdbBlockP):
    """
    Stack-based proxy class for the top-level block model.
    """

    def __init__(self, tphm):
        """
        :param tphm: Actual top model of the associated model hierarchy
        :type tphm: WmhdbBlockP
        """
        super().__init__(tphm)

    def getInstanceOutputConnectorsUserTypes(self, instance):
        block = self.proxiedElement
        return block.getInstanceOutputConnectorsUserTypes(instance)

    def getInstanceOutputConnectorsInferredTypes(self, instance):
        block = self.proxiedElement
        return block.getInstanceOutputConnectorsInferredTypes(instance)

    def getInstanceInputConnectorsUserTypes(self, instance):
        block = self.proxiedElement
        return block.getInstanceInputConnectorsUserTypes(instance)

    def getInstanceInputConnectorsInferredTypes(self, instance):
        block = self.proxiedElement
        return block.getInstanceInputConnectorsInferredTypes(instance)

    def getInputWires(self, instance):
        return self.proxiedElement.getInputWires(instance)

    def getOutputWires(self, instance):
        return self.proxiedElement.getOutputWires(instance)

    def resetWireList(self):
        return self.proxiedElement.resetWireList()

    def getBlockAndModelInstances(self):
        return self.proxiedElement.getBlockAndModelInstances()
