# ----------------------------------------------------------------------------
# - wmhdb-meta-provider                                                      -
# - wild cruncher: meta-data provider                      core / model / db -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2013-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmhdb_meta_provider
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy meta-data provider

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.db.whdb_meta_provider import WhdbMetaProvider
from wcr_core.modules.model.db.wmhdb_block import WmhdbBlock
from wcr_core.modules.model.db.wmhdb_instance_base import WmhdbInstanceBaseP
from wcr_core.modules.model.db.wmhdb_text_model import WmhdbModelText
from wcr_core.modules.model.db.wmhdb_wire import WmhdbWire
from wcr_core.modules.model.db.wmhdb_connection_point import WmhdbConnector


class WmhdbMetaProvider(WhdbMetaProvider):
    def __init__(self, blockMetas):
        """
        :param blockMetas: Block meta data
        :type blockMetas: dict[str, WdbsMetaDescriptionP]
        """
        super().__init__()

        self.__blockMetas = blockMetas

    def getBlockMeta(self, btyp=None):
        if btyp:
            meta = self.__blockMetas.get(btyp)
            if meta:
                return meta
        return WmhdbBlock.META

    def getModelMeta(self, mtyp=None):
        return WmhdbModelText.META

    def getBlockInstanceMeta(self):
        return WmhdbInstanceBaseP.META

    def getModelInstanceMeta(self):
        return WmhdbInstanceBaseP.META

    def getOperatorInstanceMeta(self, oper=None):
        return WmhdbInstanceBaseP.META

    def getConnectionMeta(self):
        return WmhdbWire.META

    def getConnectionPointMeta(self, xtyp=None):
        return WmhdbConnector.META
