# ----------------------------------------------------------------------------
# - wmhdb-model-base                                                         -
# - wild cruncher:wsh model object                         core / model / db -
# ----------------------------------------------------------------------------
# - author    (c) 2012-2013 amaury darsch                                    -
# - author    (c) 2013-2014 clemens oertel                                   -
# - copyright (c) 2012-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmhdb_model_base
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher base model object

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""

from wcr_core.db.whdb_model import WhdbModel


# noinspection PyAbstractClass
class WmhdbModel(WhdbModel):
    """
    The WmhdbModel is a base class for a model abstraction of the silkan
    hierarchy.
    """

    def __init__(self, model, wreg):
        """
        :param model: Raw model
        :type model: WdbsModelP
        :param wreg: Raw element wrapper registry
        :type wreg: WhdbWrapperRegistryP
        """
        super().__init__(model, wreg)
        self.__rawModel = model

    def setNameInfo(self, name, info):
        """
        Set both the name and the description of the model.

        :param name: New name for the model
        :type name: str
        :param info: New description for the model
        :type info: str
        """
        self.setName(name)
        self.setInfo(info)
