# ----------------------------------------------------------------------------
# - wmmod-setup                                                              -
# - wild cruncher: module setup                                 core / model -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmmod_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Model module setup

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.modules.model.db.wmhdb_xmlio import WmhdbSilkanXmlReader
from wcr_core.modules.model.plugin.wmplg_core_install_context import \
    WmpglCoreModuleInstallContextFactory
from wcr_core.modules.model.wmmod_application_module import \
    WMMOD_MODEL_APP_MODULE
from wcr_core.modules.wmod_application_module import wmod_registerModule
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_core.project.wprj_xmlio import WPRJ_SILKAN_XML_MIME_TYPE

wmod_registerModule(WMMOD_MODEL_APP_MODULE)

WPRJ_SILKAN_XML_MIME_TYPE.addReader(WmhdbSilkanXmlReader())

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WmpglCoreModuleInstallContextFactory(WMMOD_MODEL_APP_MODULE))
