# ----------------------------------------------------------------------------
# - wfact-action-base                                                        -
# - wild cruncher: state machine action base   core / statemachine / actions -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfact_action_base
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - State machine base action

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""

from wcr_core.action.wact_action import WactActionBase


# noinspection PyAbstractClass
class WfactActionBase(WactActionBase):
    def __init__(self, name, description, *parameters):
        """
        :param name: Action name
        :type name: str
        :param description: Action description
        :type description: str
        :param parameters: Action parameter descriptions
        :type parameters: list[WactActionParameterP]
        """
        super().__init__(name, description, *parameters)

    def isEnabled(self, actx):
        """
        :type actx: WactActionExecutionContextP
        """
        if not super().isEnabled(actx):
            return False
        pctx = actx.getProjectContext()
        return bool(pctx) and pctx.getModule().code == 'statemachine'
