# ----------------------------------------------------------------------------
# - wfhdb-block-proxy                                                        -
# - wild cruncher:fsm block proxy                   core / statemachine / db -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfhdb_block_proxy
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan state machine block proxy

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.db.whdb_block_proxy import WhdbHierarchyBlockProxy
from wcr_core.modules.statemachine.db.wfhdb_block import WfhdbBlockP


class WfhdbBlockProxy(WhdbHierarchyBlockProxy, WfhdbBlockP):
    def __init__(self, tphm):
        """
        :param tphm: Actual top level of the associated hierarchy
        :type tphm: WhdbBlockP
        """
        super().__init__(tphm)

    def createNestedBlockInstance(self, *args, **kwargs):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.createNestedBlockInstance(*args, **kwargs)

    def createParallelBlockInstance(self, *args, **kwargs):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.createParallelBlockInstance(*args, **kwargs)

    def setSource(self, source):
        # noinspection PyUnresolvedReferences
        self.proxiedElement.setSource(source)

    def getSource(self):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.getSource()
