# ----------------------------------------------------------------------------
# - wfhdb-meta-provider                                                   -
# - wild cruncher: meta-data provider               core / statemachine / db -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfhdb_meta_provider
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher state machine meta-data provider

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.db.whdb_block import WHDB_TOPLEVEL_BLOCK_CODE
from wcr_core.db.whdb_meta_provider import WhdbMetaProvider
from wcr_core.modules.statemachine.db.wfhdb_transition import WfhdbTransition
from wcr_core.modules.statemachine.db.wfhdb_instance import *
from wcr_core.modules.statemachine.db.wfhdb_block import *
from wcr_core.modules.statemachine.db.wfhdb_standard_operators import *


class WfhdbMetaProvider(WhdbMetaProvider):
    def getBlockMeta(self, btyp=None):
        if btyp == WFHDB_PARALLEL_BLOCK_CODE:
            return WfhdbParallelBlock.META
        elif btyp == WFHDB_NESTED_BLOCK_CODE:
            return WfhdbNestedBlock.META
        elif btyp == WHDB_TOPLEVEL_BLOCK_CODE:
            return WfhdbTopBlock.META
        else:
            return WfhdbBlockBase.META

    def getBlockInstanceMeta(self):
        return WfhdbBlockInstance.META

    def getOperatorInstanceMeta(self, oper=None):
        if oper == WFHDB_STATE_CODE:
            return WfhdbStateInstance.META
        elif oper == WFHDB_XBT_SOURCE_PROXY_CODE:
            return WfhdbXbtSourceProxyInstance.META
        elif oper == WFHDB_XBT_TARGET_PROXY_CODE:
            return WfhdbXbtTargetProxyInstance.META
        else:
            return WhdbOperatorInstance.META

    def getConnectionMeta(self):
        return WfhdbTransition.META
