# ----------------------------------------------------------------------------
# - wchdb-block                                                              -
# - wild cruncher:wsh block object                       core / sys_map / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wchdb_block
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan hierarchy blocks

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.db.whdb_block import WhdbBlock


# noinspection PyAbstractClass
class WchdbBlock(WhdbBlock):
    """
    The WchdbModelBlock class is the silkan hierarchy model block. It is used
    to construct one hierarchical level by grouping instances, functions and
    wire into several list. A block is a model and therefore is defined by name
    with an optional information string.
    """

    def __init__(self, block, wreg):
        """
        :param block: Raw block
        :type block: WdbsBlockP
        :param wreg: Raw element wrapper registry
        :type wreg: WmhdbWrapperRegistry
        """
        WhdbBlock.__init__(self, block, wreg)
