# ----------------------------------------------------------------------------
# - wchdb-standard-operators                                                 -
# - wild cruncher:standard operators                     core / sys_map / db -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wchdb_standard_operators
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher standard operators

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_core.modules.sys_map.db.wchdb_operator import WCHDB_OPER, \
    WchdbOperator
from wcr_core.db_api.whdb_protocols_api import WHDB_HALIGN_CENTER
from wcr_core.modules.sys_map.db.wchdb_connection_point_manager import \
    WchdbConnectionPointManager

WCHDB_HOST_LURE_CODE = 'wcr.sys_map.std.HOST_lure'

WCHDB_HOST_LURE = WchdbOperator(
    code=WCHDB_HOST_LURE_CODE,
    xmngr=WchdbConnectionPointManager(xpntTypes=None),
    name='Host',
    info='System Mapper representation of Hardware Host',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

WCHDB_RACK_LURE_CODE = 'wcr.sys_map.std.RACK_lure'

WCHDB_RACK_LURE = WchdbOperator(
    code=WCHDB_RACK_LURE_CODE,
    xmngr=WchdbConnectionPointManager(xpntTypes=None),
    name='RackIo',
    info='System Mapper representation of Hardware RackIo',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

WCHDB_SWITCH_LURE_CODE = 'wcr.sys_map.std.Switch_lure'

WCHDB_SWITCH_LURE = WchdbOperator(
    code=WCHDB_SWITCH_LURE_CODE,
    xmngr=WchdbConnectionPointManager(xpntTypes=None),
    name='Switch',
    info='System Mapper represntation of Hardware Switch',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

WCHDB_DEFAULT_OPS = []


WCHDB_OPER.addOperators(WCHDB_DEFAULT_OPS)
