# ----------------------------------------------------------------------------
# - wcplg-config-generator-params                                            -
# - wild cruncher: file config generator             core / sys_map / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wcplg_config_generator_params
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Cetrac file config generator balises for
   generation

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""


from wcr_core.modules.hardware.db.whhdb_connection_points import \
    WHHDB_XPOINT_CETRAC_CODE, WHHDB_XPOINT_ETHERNET_CODE, \
    WHHDB_XPOINT_AFDX_CODE, WHHDB_XPOINT_DISCRET_CODE, \
    WHHDB_XPOINT_FIBER_CHANNEL_CODE, WHHDB_XPOINT_1553_CODE,\
    WHHDB_XPOINT_ARINC825_CODE, WHHDB_XPOINT_ARINC429_CODE

PHY_GL_DESC_TAG = 'PHYSICAL_ARCHITECTURE'
PHY_OP_L_TAG = 'EQUIPMENTS_LIST'
PHY_OP_TAG = 'EQUIPMENT'
PHY_OP_NAME_TAG = 'eqpName'
PHY_OP_TYPE_TAG = 'eqpType'
PHY_OP_NUM_TAG = 'eqpPhyNum'
PHY_OP_CARD_PTP_GM_TAG = 'isPtpGrandMaster'
PHY_OP_CARD_LSB_TAG = 'cardLSBMask'
PHY_OP_CARD_MSB_TAG = 'cardMSBMask'
PHY_OP_CARD_MAX_SKEW_TAG = 'maxSkew'
PHY_OP_CARD_L_TAG = 'CARDS_LIST'
PHY_OP_CARD_TAG = 'CARD'
PHY_OP_CARD_NAME_TAG = 'cardName'
PHY_OP_CARD_TYPE_TAG = 'cardType'
PHY_OP_CARD_NUM_TAG = 'cardPhyNum'
PHY_OP_CARD_ID_TAG = 'cetracId'
PHY_OP_CARD_PORT_L_TAG = 'PORTS_LIST'
PHY_OP_CARD_PORT_TAG = 'PORT'
PHY_OP_CARD_PORT_NAME_TAG = 'portName'
PHY_OP_CARD_PORT_TYPE_TAG = 'portType'
PHY_OP_CARD_PORT_NUM_TAG = 'portPhyNum'
PHY_OP_CARD_PORT_STATE_TAG = 'porteState'
PHY_OP_CARD_PORT_PTP_TAG = 'ptpActive'
PHY_OP_CARD_PORT_PARAM_TAG = 'PORT_PARAMETERS'
PHY_OP_CARD_PORT_PARAM_FREQ_TAG = 'portFreq'
PHY_OP_CARD_PORT_PARAM_BACKBONE_TAG = 'isBackbone'
PHY_OP_CARD_PORT_PARAM_LSB_TAG = 'portLSBMask'
PHY_OP_CARD_PORT_PARAM_MSB_TAG = 'portMSBMask'
PHY_OP_CARD_PORT_PARAM_STATUS_MONITOR_TAG = 'statusReportMonitor'
PHY_OP_CARD_PORT_DISCRET_TAG = 'DISCRET_PARAMETERS'
PHY_OP_CARD_PORT_DISCRET_EVENT_IN_TAG = 'eventDataMaskIn'
PHY_OP_CARD_PORT_DISCRET_EVENT_OUT_TAG = 'eventDataMaskOut'
PHY_OP_CARD_PORT_DISCRET_CYCLIC_IN_TAG = 'cyclicDataMaskIn'
PHY_OP_CARD_PORT_DISCRET_CYCLIC_OUT_TAG = 'cyclicDataMaskOut'
PHY_OP_CARD_PORT_DISCRET_BUFFER_TAG = 'nbBuffer'
PHY_OP_CARD_PORT_DISCRET_ID_TAG = 'producerId'
PHY_OP_CARD_PORT_DISCRET_CYCLEN_TAG = 'cycleLength'
PHY_OP_CARD_PORT_1553_TAG = 'MIL1553_PARAMETERS'
PHY_OP_CARD_PORT_1553_ID_TAG = 'prodId'
PHY_OP_CARD_PORT_1553_SEQUENCE_TAG = 'sequenceNumber'
PHY_OP_CARD_PORT_1553_CYCLE_TAG = 'clockCycle'
PHY_OP_CARD_PORT_FB_TAG = 'FIBER_CHANNEL_PARAMETERS'
PHY_OP_CARD_PORT_FB_MFL_TAG = 'maxFrameLength'
PHY_OP_CARD_PORT_FB_IPCONF_TAG = 'ipConfiguration'
PHY_OP_CARD_PORT_FB_FRFT_TAG = 'fifoReceiveFullTreshold'
PHY_OP_CARD_PORT_FB_FTFT_TAG = 'fifoTransmitFullTreshold'
PHY_OP_CARD_PORT_FB_FTET_TAG = 'fifoTransmitEmptyTreshold'
PHY_OP_CARD_PORT_FB_FRAET_TAG = 'fifoReceiveAlmostEmptyTreshold'
PHY_OP_CARD_PORT_FB_FRAFT_TAG = 'fifoReceiveAlmostFullTreshold'
PHY_OP_CARD_PORT_FB_FTAET_TAG = 'fifoTransmitAlmostEmptyTreshold'
PHY_OP_CARD_PORT_FB_FTAFT_TAG = 'fifoTransmitAlmostFullTreshold'
PHY_OP_CARD_PORT_FB_ITV_TAG = 'initializationTimerValue'
PHY_OP_CARD_PORT_FB_ETV_TAG = 'eventTimeoutValue'
PHY_OP_CARD_PORT_AFDX_TAG = 'A664P7_PARAMETERS'
PHY_OP_CARD_PORT_AFDX_DELAY_TAG = 'maxDelay'
PHY_OP_CARD_PORT_AFDX_HIGHTBUFFER_TAG = 'highPriorityBufferSize'
PHY_OP_CARD_PORT_AFDX_LOWBUFFER_TAG = 'lowPriorityBufferSize'
PHY_OP_CARD_PORT_AFDX_NETWORK_TAG = 'networkId'
PHY_OP_CARD_PORT_AFDX_INTERFACE_TAG = 'interFaceId'
PHY_OP_CARD_PORT_AFDX_SIDE_TAG = 'sideId'
PHY_OP_CARD_PORT_AFDX_LOCATION_TAG = 'locationId'
PHY_OP_CARD_PORT_ARINC825_TAG = 'ARINC825_PORT_PARAMETERS'
PHY_OP_ARINC825_ID_TAG = 'producerID'
PHY_OP_ARINC825_DATA_RATE_TAG = 'dataRate'
PHY_OP_ARINC825_ARBITRATION_SPEED_TAG = 'arbitBaudRate'
PHY_OP_ARINC825_DATA_SPEED_TAG = 'dataBaudRate'
PHY_OP_ARINC825_FILTER_TAG = 'acceptanceFilterMode'
PHY_OP_ARINC825_CLOCK_ACTIVATE_TAG = 'clockActivated'
PHY_OP_ARINC825_CLOCK_DIVIDER_TAG = 'clockDivider'
PHY_OP_ARINC825_LISTEN_TAG = 'listenOnlyMode'
PHY_OP_ARINC825_MAX_FRAME_TAG = 'maxNbFrame'
PHY_OP_ARINC825_SELF_TEST_TAG = 'selfTestEnable'
PHY_OP_ARINC825_TIMEOUT_TAG = 'cycleTime'
PHY_OP_ARINC825_CYCLIC_MODE_TAG = 'cyclicMode'
PHY_OP_CARD_PORT_ARINC429_TAG = 'ARINC429_PORT_PARAMETERS'
PHY_PORT_L_TAG = 'PORTS_LINKS_LIST'
PHY_PORT_TAG = 'PORTS_LINK'
PHY_PORT_PNAME1_TAG = 'portName1'
PHY_PORT_PNAME2_TAG = 'portName2'


LOG_GL_DESC_TAG = 'LOGICAL_ARCHITECTURE'
LOG_APP_L_TAG = 'APPLICATIONS_LIST'
LOG_APP_TAG = 'APPLICATION'
LOG_APP_NAME_TAG = 'appName'
LOG_APP_HOST_TAG = 'hostCard'
LOG_APP_TYPE_TAG = 'appType'
LOG_APP_PERIOD_TAG = 'appPeriod'
LOG_TR_L_TAG = 'TRAFFIC_ROUTES_LIST'
LOG_TR_TAG = 'TRAFFIC_ROUTE'
LOG_TR_STORAGE_TAG = 'storageMethod'
LOG_TR_BUFFER_TAG = 'nbBuffers'
LOG_TR_FRAMESIZE_TAG = 'frameSize'
LOG_TR_TYPE_TAG = 'type'
LOG_TR_TRANSMITTTER_TAG = 'transmitterPortName'
LOG_TR_PROD_APP_TAG = 'producerAppName'
LOG_TR_MSG_LIST_TAG = 'MESSAGE_LIST'
LOG_TR_MSG_TAG = 'MESSAGE'
LOG_TR_MSG_DATA_NAME_TAG = 'dataName'
LOG_TR_MSG_PAYLOAD_TAG = 'payloadSize'
LOG_TR_VARIABLE_LIST_TAG = 'VARIABLE_LIST'
LOG_TR_VARIABLE_TAG = 'VARIABLE'
LOG_TR_VAR_NAME_TAG = 'varName'
LOG_TR_VAR_OFFSET_TAG = 'offset'
LOG_TR_VAR_TYPE_TAG = 'varType'
LOG_TR_REC_PORT_L_TAG = 'RECEIVERS_PORTS_LIST'
LOG_TR_REC_PORT_TAG = 'RECEIVER_PORT'
LOG_TR_REC_PORT_ID_TAG = 'receiverPortName'
LOG_TR_DETERMINIST_TAG = 'DETERMINIST_PARAMETERS'
LOG_TR_CAPP_L_TAG = 'CONSUMERS_APPLICATIONS_LIST'
LOG_TR_CAPP_TAG = 'CONSUMER_APPLICATION'
LOG_TR_CAPP_NAME_TAG = 'consumerAppName'
LOG_TR_AFDX_TAG = 'A664P7_PARAMETERS'
LOG_TR_AFDX_NUMBER_TAG = 'vlNum'
LOG_TR_AFDX_BAG_TAG = 'bag'
LOG_TR_AFDX_JITTER_TAG = 'jitter'
LOG_TR_AFDX_LMAX_TAG = 'lmax'
LOG_TR_AFDX_LMIN_TAG = 'lmin'
LOG_TR_AFDX_REDNT_MGNT_TAG = 'redundancyManagement'
LOG_TR_AFDX_REDNT_VL_TAG = 'redundantVL'
LOG_TR_AFDX_SN_CHECK_TAG = 'snIntegrityCheck'
LOG_TR_AFDX_PRIO_TAG = 'priority'
LOG_TR_ETH_TAG = 'ETH_PARAMETERS'
LOG_TR_ETH_MAC_DEST_TAG = 'mac_dst'
LOG_TR_ETH_MAC_SRC_TAG = 'mac_src'
LOG_TR_ETH_IP_SRC_TAG = 'ip_src'
LOG_TR_ETH_IP_DEST_TAG = 'ip_dst'
LOG_TR_ETH_PROTOCOL_TAG = 'protocol'
LOG_TR_ETH_UDP_TAG = 'udp_support'
LOG_TR_ETH_TCP_TAG = 'tcp_support'
LOG_TR_ETH_ICMP_TAG = 'icmp_support'
LOG_TR_ETH_ARP_TAG = 'arp_support'
LOG_TR_ETH_DETER_TAG = 'isDeterminist'
LOG_TR_ARINC825_TAG = 'ARINC825_PARAMETERS'
LOG_TR_ARINC825_ID_TAG = 'arinc825_id'
LOG_TR_ARINC429_LABEL_L_TAG = 'ARINC429_LABELS_LIST'
LOG_TR_ARINC429_LABEL_TAG = 'ARINC429_LABEL'
LOG_TR_ARINC429_ID_TAG = 'id'

LOG_BUS_VL_PAPP_L_TAG = 'PRODUCERS_APPLICATIONS_LIST'
LOG_BUS_VL_PAPP_TAG = 'PRODUCER_APPLICATION'
LOG_BUS_VL_PAPP_NAME_TAG = 'producerApplicationName'
LOG_BUS_VL_CAPP_L_TAG = 'CONSUMERS_APPLICATIONS_LIST'
LOG_BUS_VL_CAPP_TAG = 'CONSUMER_APPLICATION'
LOG_BUS_VL_CAPP_NAME_TAG = 'consumerApplicationName'
LOG_BUS_VL_SRC_PORT_L_TAG = 'TRANSMITTERS_PORTS_LIST'
LOG_BUS_VL_SRC_PORT_TAG = 'TRANSMITTER_PORT'
LOG_BUS_VL_SRC_PORT_ID_TAG = 'transmitterPortName'
LOG_BUS_VL_CNS_PORT_L_TAG = 'RECEIVERS_PORTS_LIST'
LOG_BUS_VL_CNS_PORT_TAG = 'RECEIVER_PORT'
LOG_BUS_VL_CNS_PORT_ID_TAG = 'receiverPortName'

HOST_EQ_TYPE = 'host'
PROS_EQ_TYPE = 'Processor'
CET_SW = 'cetracswitch'
CET_IO = 'cetracIO'
PHY_EQ_TYPE_LIST = [CET_SW, PROS_EQ_TYPE, CET_IO,
                    HOST_EQ_TYPE]

EXT_CARD_TYPE = 'Extern'
CET_CARD_TYPE = 'CetracPCI'
CET_SW_CARD_TYPE = 'CetracBS'
CET_RACK_CARD_TYPE = 'CetracLS'

PHY_EQ_CARD_TYPE_LIST = [CET_CARD_TYPE, CET_SW_CARD_TYPE,
                         CET_RACK_CARD_TYPE, EXT_CARD_TYPE]

EXT_APP_TYPE = 'externApp'
CB_APP_TYPE = 'mitracApp'
LOG_APP_TYPE_LIST = [CB_APP_TYPE, EXT_APP_TYPE]

WVHDB_VLINK_TYPE_CETRAC = WHHDB_XPOINT_CETRAC_CODE
WVHDB_VLINK_TYPE_ETNERNET = 'ETH'
WVHDB_VLINK_TYPE_AFDX = 'AFDX'
WVHDB_VLINK_TYPE_DISCRETE = 'DISCRETE'
WVHDB_VLINK_TYPE_1553 = WHHDB_XPOINT_1553_CODE
WVHDB_VLINK_TYPE_FIBER = 'FIBER_CHANNEL'
WVHDB_VLINK_TYPE_ARINC825 = WHHDB_XPOINT_ARINC825_CODE
WVHDB_VLINK_TYPE_ARINC429 = WHHDB_XPOINT_ARINC429_CODE

HW_2_VL_TYPE = {WHHDB_XPOINT_CETRAC_CODE: WVHDB_VLINK_TYPE_CETRAC,
                WHHDB_XPOINT_ETHERNET_CODE: WVHDB_VLINK_TYPE_ETNERNET,
                WHHDB_XPOINT_AFDX_CODE: WVHDB_VLINK_TYPE_AFDX,
                WHHDB_XPOINT_DISCRET_CODE: WVHDB_VLINK_TYPE_DISCRETE,
                WHHDB_XPOINT_1553_CODE: WVHDB_VLINK_TYPE_1553,
                WHHDB_XPOINT_FIBER_CHANNEL_CODE: WVHDB_VLINK_TYPE_FIBER,
                WHHDB_XPOINT_ARINC825_CODE: WHHDB_XPOINT_ARINC825_CODE,
                WHHDB_XPOINT_ARINC429_CODE: WHHDB_XPOINT_ARINC429_CODE,}


XML_CETRAC = 'CETRAC'
XML_ETHERNET = 'ETH'
XML_AFDX = 'A664P7'
XML_DISCRETE = 'DISCRET'
XML_1553 = 'MIL1553'
XML_FIBER_CHANNEL = 'FIBER_CHANNEL'


HARD_NETWORK_TYPE = {WHHDB_XPOINT_CETRAC_CODE: XML_CETRAC,
                     WHHDB_XPOINT_ETHERNET_CODE: XML_ETHERNET,
                     WHHDB_XPOINT_AFDX_CODE: XML_AFDX,
                     WHHDB_XPOINT_DISCRET_CODE: XML_DISCRETE,
                     WHHDB_XPOINT_1553_CODE: XML_1553,
                     WHHDB_XPOINT_FIBER_CHANNEL_CODE: XML_FIBER_CHANNEL,
                     WHHDB_XPOINT_ARINC825_CODE: WVHDB_VLINK_TYPE_ARINC825,
                     WHHDB_XPOINT_ARINC429_CODE: WVHDB_VLINK_TYPE_ARINC429,
                     }

VL_NETWORK_TYPE = {WVHDB_VLINK_TYPE_CETRAC: XML_CETRAC,
                   WVHDB_VLINK_TYPE_ETNERNET: XML_ETHERNET,
                   WVHDB_VLINK_TYPE_AFDX: XML_AFDX,
                   WVHDB_VLINK_TYPE_1553: XML_1553,
                   WVHDB_VLINK_TYPE_DISCRETE: XML_DISCRETE,
                   WVHDB_VLINK_TYPE_FIBER: XML_FIBER_CHANNEL,
                   WVHDB_VLINK_TYPE_ARINC825: WHHDB_XPOINT_ARINC825_CODE,
                   WVHDB_VLINK_TYPE_ARINC429: WHHDB_XPOINT_ARINC429_CODE,
                  }

####
# All supposed supported network type
# CETRAC, AFDX, UDP_IP, TCP_IP, ETHERNET, CAN, CAN +, ARINC429,
# MILSTD1553, VISTAS_AFDX, VISTAS_ETHERNET, VISTAS_CAN, VISTAS_CAN +,
# VISTAS_ARINC429, VISTAS_MILSTD1553.
####

DFT_VAL = hex(0)
FRAME_SIZE_OVER_PAYLOAD = 1456


def WcplgGetAllRouteOfSameCodeFromPort(portObject, allRoutes):
    routes = []
    pCode = portObject.getCode()
    xmlPCode = HARD_NETWORK_TYPE[pCode]
    for routeName, routeObject in allRoutes:
        xmlRouteCode = VL_NETWORK_TYPE[routeObject.getVLType()]
        isCetrac = (xmlRouteCode == XML_CETRAC or xmlPCode == XML_CETRAC)
        if xmlPCode == xmlRouteCode or isCetrac:
            routes.append((routeName, routeObject))
    return routes


def WcplgGetAllPortOfSameCodeFromRoute(routeObject, allPorts):
    ports = []
    rCode = routeObject.getVLType()
    xmlRCode = VL_NETWORK_TYPE[rCode]
    for portName, portObject in allPorts:
        xmlPortCode = HARD_NETWORK_TYPE[portObject.getCode()]
        isCetrac = (xmlPortCode == XML_CETRAC or xmlRCode == XML_CETRAC)
        if xmlPortCode == xmlRCode or isCetrac:
            ports.append((portName, portObject))
    return ports