# ----------------------------------------------------------------------------
# - wcmod-setup                                                              -
# - wild cruncher: hardware setup                             core / Sys-map -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wcmod_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - system mapper module setup

.. moduleauthor:: philippe lambert <lambert@silkan.com>
"""
from wcr_core.modules.sys_map.plugin.wcplg_core_install_context import \
    WcpglCoreModuleInstallContextFactory
from wcr_core.modules.sys_map.wcmod_application_module import \
    WCMOD_SYSTEM_MAP_APP_MODULE
from wcr_core.modules.wmod_application_module import wmod_registerModule
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_core.modules.sys_map.wcmod_connection_point_type import \
    WcmodConnectionPointType
from wcr_core.modules.sys_map.db.wchdb_connection_points import *


WCMOD_STD_XPOINT = WcmodConnectionPointType(
    WCHDB_XPOINT_STD_CODE, 'Standart', 'std', WchdbStdXPoint,
    cfgMeta=WCHDB_XPOINT_STD_CONFIG_META,
    crtnArgs=WCHDB_XPOINT_STD_DFLT_ARGS)

WCMOD_SYSTEM_MAP_APP_MODULE.addConnectionPointType(WCMOD_STD_XPOINT)

wmod_registerModule(WCMOD_SYSTEM_MAP_APP_MODULE)

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WcpglCoreModuleInstallContextFactory(WCMOD_SYSTEM_MAP_APP_MODULE))
