# ----------------------------------------------------------------------------
# - wphdb-block-proxy                                                        -
# - wild cruncher:sys block proxy                         core / system / db -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - author    (c) 2014-2014 samuel longchamps                                -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wphdb_block_proxy
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher silkan system mapper block proxy

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
.. moduleauthor:: Samuel Longchamps <samuel.longchamps@silkan.com>
"""
from wcr_core.db.whdb_block_proxy import WhdbHierarchyBlockProxy
from wcr_core.modules.system.db.wphdb_block import WphdbBlockP


class WphdbBlockProxy(WhdbHierarchyBlockProxy, WphdbBlockP):
    def __init__(self, tphm):
        """
        :param tphm: Actual top level of the associated hierarchy
        :type tphm: WphdbBlockP
        """
        super().__init__(tphm)

    def createClusterInstance(self, *args, **kwargs):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.createClusterInstance(*args, **kwargs)

    def createHostInstance(self, *args, **kwargs):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.createHostInstance(*args, **kwargs)

    def createPhyBusInstance(self, *args, **kwargs):
        # noinspection PyUnresolvedReferences
        return self.proxiedElement.createPhyBusInstance(*args, **kwargs)
