# ----------------------------------------------------------------------------
# - wphdb-phybus-meta                                                        -
# - wild cruncher: phybus meta-data                       core / system / db -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 samuel longchamps                                -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. :module:       wphdb_phybus_mote
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Physical bus meta-data

.. moduleauthor:: Samuel Longchamps <samuel.longchamps@silkan.com>
"""
from wcr_core.db.whdb_instance import WhdbOperatorInstance
from wcr_core.dbstore.wdbs_meta_description import WdbsMetaDescription, \
    WdbsMetaField
from wcr_core.dbstore.wdbs_meta_type import WdbsListMetaType, WDBS_UUID_META


WPHDB_BUS_BOUND_LBUS_KEY = 'blbus'

WPHDB_BUS_STR_DESCRIPTION = 'UUID list of the bound logical bus(es)'

WPHDB_BUS_METATYPE_LBUSES = WdbsListMetaType(WDBS_UUID_META)

WPHDB_BUS_META_DESCRIPTION = WdbsMetaDescription(
    WhdbOperatorInstance.META,
    WdbsMetaField(
        WPHDB_BUS_BOUND_LBUS_KEY,
        WPHDB_BUS_METATYPE_LBUSES,
        WPHDB_BUS_STR_DESCRIPTION)
    )