# ----------------------------------------------------------------------------
# - wphdb-standard-operator                                                  -
# - wild cruncher:standard operators                      core / system / db -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - author    (c) 2014-2014 samuel longchamps                                -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wphdb_standard_operator
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher state machine hierarchy standard operators

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
.. moduleauthor:: Samuel Longchamps <samuel.longchamps@silkan.com>
"""
from wcr_core.db_api.whdb_protocols_api import WHDB_HALIGN_CENTER
from wcr_core.modules.system.db.wphdb_operator import WPHDB_OPER, WphdbOperator
from wcr_core.modules.system.db.wphdb_connection_point_manager import \
    WphdbConnectionPointManager

WPHDB_HOST_CODE = 'wcr.system.std.host'
WPHDB_BUS_CODE = 'wcr.system.std.bus'


#: Host operator
WPHDB_HOST = WphdbOperator(
    code=WPHDB_HOST_CODE,
    xmngr=WphdbConnectionPointManager(xpntTypes=None),
    name='Host',
    info='Host',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

WPHDB_BUS = WphdbOperator(
    code=WPHDB_BUS_CODE,
    xmngr=WphdbConnectionPointManager(xpntTypes=None),
    name='Bus',
    info='Physical Bus',
    symbol='',
    labelAlign=WHDB_HALIGN_CENTER)

#: System mapper default operators
WPHDB_DEFAULT_OPS = [WPHDB_HOST, WPHDB_BUS]

WPHDB_OPER.addOperators(WPHDB_DEFAULT_OPS)

