# ----------------------------------------------------------------------------
# - wpmod-setup                                                              -
# - wild cruncher: module setup                                core / system -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wpmod_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - System module setup

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.modules.system.db.wphdb_connection_points import \
    WPHDB_XPOINT_ETHERNET_CODE, WphdbEthernetXPoint, \
    WPHDB_XPOINT_ETH_CONFIG_META, WPHDB_XPOINT_ETH_DFLT_ARGS
from wcr_core.modules.system.plugin.wpplg_core_install_context import \
    WppglCoreModuleInstallContextFactory
from wcr_core.modules.system.wpmod_application_module import \
    WPMOD_SYSTEM_APP_MODULE
from wcr_core.modules.system.wpmod_connection_point_type import \
    WpmodConnectionPointType
from wcr_core.modules.system.wpmod_distrib_service_default_types import \
    WPMOD_ETHERNET_DISTRIBUTION_SERVICE_TYPE
from wcr_core.modules.wmod_application_module import wmod_registerModule
from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY

WPMOD_SYSTEM_APP_MODULE.addDistributionServiceType(
    WPMOD_ETHERNET_DISTRIBUTION_SERVICE_TYPE)

WPMOD_ETHERNET_XPOINT = WpmodConnectionPointType(
    WPHDB_XPOINT_ETHERNET_CODE, 'Ethernet', 'eth', WphdbEthernetXPoint,
    cfgMeta=WPHDB_XPOINT_ETH_CONFIG_META, crtnArgs=WPHDB_XPOINT_ETH_DFLT_ARGS)

WPMOD_SYSTEM_APP_MODULE.addConnectionPointType(WPMOD_ETHERNET_XPOINT)

wmod_registerModule(WPMOD_SYSTEM_APP_MODULE)

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WppglCoreModuleInstallContextFactory(WPMOD_SYSTEM_APP_MODULE))
