# ----------------------------------------------------------------------------
# - wplg-core-install-context-factory                                        -
# - wild cruncher: core install context factory                core / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wplg_core_install_context_factory
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Core install context factory

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.plugin.wplg_core_install_context import WPLG_CORE_INSTALL_CODE, \
    WplgCorePlatformInstallContext, WplgCoreModuleInstallContext
from wcr_core.plugin.wplg_install_context_factory_api import \
    WplgPlatformInstallContextFactoryP, WplgModuleInstallContextFactoryP, \
    WplgInstallContextFactoryP


# noinspection PyAbstractClass
class WplgCoreInstallContextFactoryMixin(WplgInstallContextFactoryP):
    def getComponentCode(self):
        return WPLG_CORE_INSTALL_CODE


class WplgCorePlatformInstallContextFactory(
        WplgPlatformInstallContextFactoryP,
        WplgCoreInstallContextFactoryMixin):
    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WplgCorePlatformInstallContext(plgCode, plgName, plgDesc)


class WplgCoreModuleInstallContextFactory(
        WplgModuleInstallContextFactoryP,
        WplgCoreInstallContextFactoryMixin):
    def __init__(self, module):
        """
        :param module: Application module
        :type module: WmodApplicationModuleMP
        """
        self.__module = module

    def getModuleCode(self):
        return self.__module.code

    def createInstallContext(self, plgCode, plgName, plgDesc, *args, **kwargs):
        return WplgCoreModuleInstallContext(
            plgCode, plgName, plgDesc, self.__module)
