# ----------------------------------------------------------------------------
# - wplg-plugin-reader                                                       -
# - wild cruncher: plugin reader                               core / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wplg_plugin_reader
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Plugin reader

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""


class WplgPluginReader(object):
    """
    Reader for plug-ins.
    """
    def __init__(self, installer):
        """
        :param installer: Plugin installer
        :type installer: WplgInstaller
        """
        self.__installer = installer

        self.__plugins = []
        """:type: list[WplgPluginReaderPluginP]"""

        #self._findPlugins()

    # def _findPlugins(self):
    #     for f in scmn_listdir(scmn_path_dir(__file__),
    #                           pattern=r'wplg_\w+_reader_plugin.py'):
    #         f, fs = f.rsplit('.', 1)
    #         f = 'wcr_core.plugin.{}'.format(f)
    #         print('LOADING PLUGIN FILE', f)
    #         pmod = import_module(f)
    #         for d in dir(pmod):
    #             m = re.match(r'^Wplg\w+Plugin$', d)
    #             if m:
    #                 print('  FOUND PLUGIN', d)
    #                 clzz = getattr(pmod, d)
    #                 self.__plugins.append(clzz())

    def addReaderPlugin(self, plugin):
        """
        Add a plugin-reader plugin.

        :param plugin: Plugin-reader plugin to be added
        :type plugin: WplgPluginReaderPluginP
        """
        self.__plugins.append(plugin)

    def readAll(self, path):
        """
        Find and read plugins at the given path.

        :param path: Path to read plugins from
        :type path: str
        """
        for plg in self.__plugins:
            plg.readAll(path, self.__installer)
