# ----------------------------------------------------------------------------
# - wplg-plugin-reader-plugin-api                                            -
# - wild cruncher: plugin reader plugin api                    core / plugin -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wplg_plugin_reader_plugin_api
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Plugin reader plugin API

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import ABCMeta, abstractmethod


class WplgPluginReaderPluginP(metaclass=ABCMeta):
    """
    Plugin-reader plugin protocol.
    """

    @abstractmethod
    def readAll(self, path, installer):
        """
        Find and read/install plugins at the given path.

        :param path: Path to read plugins from
        :type path: str
        :param installer: Plugin installer for installation of found plugins
        :type installer: WplgInstaller
        """
        raise NotImplementedError()
