# ----------------------------------------------------------------------------
# - wgui-action-execution-context-api                                        -
# - wild cruncher: action execution context api               frontend / gui -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wgui_action_execution_context_api
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - GUI action execution context API

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from abc import abstractmethod

from wcr_core.action.wact_action_execution_context import \
    WactActionExecutionContextP


# noinspection PyAbstractClass
class WguiActionExecutionContextP(WactActionExecutionContextP):
    """
    GUI execution context.
    """

    @abstractmethod
    def getEditor(self):
        """
        Get the current editor.

        :return: Editor
        :rtype: WguiEditor
        """
        raise NotImplementedError()

    @abstractmethod
    def getParent(self):
        """
        Get the parent widget.

        :return: Parent widget
        :rtype: QWidget
        """
        raise NotImplementedError()
