# ----------------------------------------------------------------------------
# - wgui-global-props-dialog                                                 -
# - wild cruncher - cockpit: global properties dialog widgets                -
# ----------------------------------------------------------------------------
# - author    (c) 2013-2013 clemens oertel                                   -
# - copyright (c) 2013-2013 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wgui_global_props_dialog
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher global properties dialog

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from wcr_core.wcor_context import wcor_getConfigDefaults
from wcr_frontend.gui.wgui_project_props_dialog import \
    WguiEditorConfigProperties
from wcr_frontend.gui.wgui_props_dialog_widget import \
    WguiConfigTableProperties, WguiPropertiesDialog


class WguiGlobalPropertiesDialog(WguiPropertiesDialog):
    """
    The WguiGlobalPropertiesDialog class is a dialog design to access
    and manipulate global preferences and system configuration settings.
    """

    def __init__(self, cfgTable, config, parent=None):
        """
        :param cfgTable: Global configuration table
        :type cfgTable: ScmnConfigTable
        :param config: global project editor config
        :type config: WguiProjectEditorCfg
        :param parent: Parent widget
        """
        super().__init__('Global Settings', parent=parent)

        self.setTabbedPropertyWidgets(
            ('Config Table',
             WguiConfigTableProperties(
                 cfgTable, defaults=wcor_getConfigDefaults())),
            ('Editor', WguiEditorConfigProperties(config))
        )
