# ----------------------------------------------------------------------------
# - wbgui-props-dialog-factory                                               -
# - wild cruncher - cockpit: properties dialog box factory                   -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbgui_props_dialog_factory
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher properties dialog box factory

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_frontend.gui.wgui_props_dialog_factory import \
    WguiPropertiesDialogFactory
from wcr_core.modules.bus.db.wbhdb_standard_operators import WBHDB_BUS, \
    WBHDB_EXT_MODULE
from wcr_frontend.modules.bus.gui.wbgui_external_module_instance_props_dialog \
    import WbguiExtModulePropertiesDialog
from wcr_frontend.modules.bus.gui.wbgui_bus_instance_props_dialog import \
    WbguiBusPropertiesDialog

WBHDB_STD_OPERINST_PROPDLG = {WBHDB_BUS: WbguiBusPropertiesDialog,
                              WBHDB_EXT_MODULE: WbguiExtModulePropertiesDialog}


class WbguiPropertiesDialogFactory(WguiPropertiesDialogFactory):
    def __init__(self, prjContext, config, scene, actions, parent=None):
        """
        :param prjContext: Project context
        :type prjContext: WcorProjectContextP
        :param config: Project editor configuration
        :type config: WguiProjectEditorCfgP
        :param scene: Graphic scene adapter
        :type scene: WguiSceneAdapterP
        :param actions: GUI actions
        :type actions: dict[str, WactActionP]
        :param parent: Parent widget
        """
        super().__init__(prjContext, config, scene, actions, parent)

    def _createOperatorInstancePropertiesDialog(self, inst, pctx, updateF,
                                                selectXpnt, parent):

        propDlg = WBHDB_STD_OPERINST_PROPDLG.get(inst.getOperator())
        if propDlg is not None:
            return propDlg(inst, pctx, updateF, selectXpnt, parent)
        else:
            return super()._createOperatorInstancePropertiesDialog(
                    inst, pctx, updateF, selectXpnt, parent)