# ----------------------------------------------------------------------------
# - whgui-operator-instance-props-dialog                                     -
# - wild cruncher - cockpit : Iperator instance properties dialog widgets    -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbgui_Operator_Instance_props_dialog
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher Cetrac Switch instance properties dialog

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_frontend.gui.wgui_operator_instance_props_dialog import \
    WguiOperatorInstancePropertiesDialog
from \
wcr_frontend.modules.hardware.gui.whgui_Operator_connection_points_props_widget\
    import WhguiOperatorInstanceXPointProperties

from wcr_frontend.modules.hardware.gui.whgui_Operator_Modules_Io_props_widget\
    import WhguiOperatorModulesIoProperties

class WhguiOperatorInstancePropertiesDialog(
    WguiOperatorInstancePropertiesDialog):
    _TYPE_NAME = 'Operator Instance'

    _SHOW_OPERATOR_WIDGET = False

    def __init__(self, inst, pctx, updateF, selectXpnt=None, parent=None,
                 ConF=None):
        """
        :param inst: the instance object
        :type inst: WhdbInstanceP
        :param pctx: Project context
        :type pctx: WcorProjectContextP
        :param updateF: Callback function to notify about saves
        :type updateF: () -> _
        :param parent: Parent widget
        """
        self.__connectionF = ConF
        super().__init__(inst, pctx, updateF, selectXpnt, parent)
        self.setMinimumHeight(500)

    def _createAdditionalInstancePropertiesWidgets(self, inst, pctx):
        return []

    # noinspection PyMethodMayBeStatic
    def _createAdditionalPropertiesWidgets(self, inst, pctx):
        return []

    def _createConnectionPointsPropertiesWidget(self, inst, pctx):
        return 'Conn. Points', \
               WhguiOperatorInstanceXPointProperties(inst, pctx,
                                            ConverifF=self.__connectionF)

    # def _createModuleIOPropertiesWidget(self, inst, pctx):
    #     return 'Modules IO', \
    #            WhguiOperatorModulesIoProperties(inst, pctx,
    #                                         ConverifF=self.__connectionF)
