# ----------------------------------------------------------------------------
# - whgui-Rack-instance-props-dialog                                         -
# - wild cruncher - cockpit : Rack properties dialog widgets                 -
# ----------------------------------------------------------------------------
# - author    (c) 2017-2017 achraf mahti                                     -
# - copyright (c) 2017-2017 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wbgui_rack_instance_props_dialog
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher Rack instance properties dialog

.. moduleauthor:: Achraf Mahti <mahti@silkan.net>
"""

from wcr_frontend.gui.wgui_operator_instance_props_dialog import \
    WguiOperatorInstancePropertiesDialog
from wcr_frontend.modules.hardware.gui.whgui_rack_cards_props_widget \
    import WhguiRackXPointProperties

class WhguiRackPropertiesDialog(
    WguiOperatorInstancePropertiesDialog):
    _TYPE_NAME = 'Rack Instance'

    _SHOW_OPERATOR_WIDGET = False

    def __init__(self, inst, pctx, updateF, scene, selectXpnt=None,
                 parent=None, ConF=None):
        """
        :param inst: the instance object
        :type inst: WhdbInstanceP
        :param pctx: Project context
        :type pctx: WcorProjectContextP
        :param updateF: Callback function to notify about saves
        :type updateF: () -> _
        :param parent: Parent widget
        """
        self.__connectionF = ConF
        self.__scene = scene
        self.__updateF = updateF
        super().__init__(inst, pctx, updateF, selectXpnt, parent)


    def _createAdditionalInstancePropertiesWidgets(self, inst, pctx):
        return []

    # noinspection PyMethodMayBeStatic
    def _createAdditionalPropertiesWidgets(self, inst, pctx):
        return []

    def _createConnectionPointsPropertiesWidget(self, inst, pctx):
        self.rackCards = WhguiRackXPointProperties(inst, pctx, self.__scene,
                                  ConverifF=self.__connectionF,
                                  updateF=self.__updateF)
        return 'Cards', self.rackCards

    def closeEvent(self, event):
        for propDialog in self.rackCards.getCardTab().dialogs:
            propDialog.close()
