# ----------------------------------------------------------------------------
# - whgui-setup                                                              -
# - wild cruncher: gui hardware setup              frontend / hardware / gui -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2015 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       whgui_setup
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher - Model GUI module setup

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

# noinspection PyUnresolvedReferences
import wcr_core.modules.hardware.whmod_setup

from wcr_core.plugin.wplg_install_context_registry import \
    WPLG_INSTALL_CONTEXT_REGISTRY
from wcr_frontend.gui.wgui_gui_module import wgui_registerCockpitModule
from wcr_frontend.gui_plugin.wgui_gui_install_context_factory import \
    WguiGuiModuleInstallContextFactory
from wcr_frontend.modules.hardware.gui.whgui_hardware_gui_module import \
    WHGUI_COCKPIT_SYSTEM_MODULE


wgui_registerCockpitModule(WHGUI_COCKPIT_SYSTEM_MODULE)

WPLG_INSTALL_CONTEXT_REGISTRY.registerInstallContextFactory(
    WguiGuiModuleInstallContextFactory(WHGUI_COCKPIT_SYSTEM_MODULE))
