# ----------------------------------------------------------------------------
# - wigui-props-dialog-factory                                               -
# - wild cruncher - cockpit: properties dialog box factory                   -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wigui_props_dialog_factory
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher properties dialog box factory

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_frontend.gui.wgui_props_dialog_factory import \
    WguiPropertiesDialogFactory
from wcr_frontend.modules.icd.gui.wigui_project_props_dialog import \
    WiguiProjectPropertiesDialog
from wcr_core.modules.icd.db.wihdb_standard_operators import WIHDB_MODULE
from wcr_frontend.modules.icd.gui.wigui_module_instance_props_dialog import \
    WiguiModuleInstancePropertiesDialog

WIHDB_STD_OPERINST_PROPDLG = {WIHDB_MODULE: WiguiModuleInstancePropertiesDialog}


class WiguiPropertiesDialogFactory(WguiPropertiesDialogFactory):
    def __init__(self, prjContext, config, scene, actions, parent=None):
        """
        :param prjContext: Project context
        :type prjContext: WcorProjectContextP
        :param config: Project editor configuration
        :type config: WguiProjectEditorCfgP
        :param scene: Graphic scene adapter
        :type scene: WguiSceneAdapterP
        :param actions: GUI actions
        :type actions: dict[str, WactActionP]
        :param parent: Parent widget
        """
        super().__init__(prjContext, config, scene, actions, parent)
        self.__scene = scene
    def _createProjectPropertiesDialog(self, prjContext, config, updateF,
                                           parent):
        return WiguiProjectPropertiesDialog(
            prjContext, config, updateF, self.__scene, parent=parent)

    def _createOperatorInstancePropertiesDialog(self, inst, pctx, updateF,
                                                selectXpnt, parent):
        propDlg = WIHDB_STD_OPERINST_PROPDLG.get(inst.getOperator())
        if propDlg is not None:
            return propDlg(inst, pctx, updateF, selectXpnt, parent)
        else:
            return super()._createOperatorInstancePropertiesDialog(
                inst, pctx, updateF, selectXpnt, parent)