# ----------------------------------------------------------------------------
# - wigui-scene-context-menu-factory                                         -
# - wild cruncher - cockpit: scene-based context menu factory                -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wigui_scene_context_menu_factory
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher scene-based context menu factory

.. moduleauthor:: Philippe lambert <lambert@silkan.com>
"""

from wcr_frontend.gui.wgui_scene_context_menu_factory import \
    WguiSceneContextMenuFactory


class WiguiSceneContextMenuFactory(WguiSceneContextMenuFactory):
    """
    Context menu generate based on the WCR graphics scene.
    """

    def __init__(self, scene, actions, clpbrd, pctx, pdgf):
        """
        :param scene: Graphics scene
        :type scene: WguiSceneAdapterP
        :param actions: Action dictionary
        :type actions: dict[str, WactActionP]
        :param clpbrd: Clipboard handler
        :type clpbrd: WguiClipboardHandler
        :param pctx: Project context
        :type pctx: WcorProjectContextP
        :param pdgf: Properties dialog factory
        :type pdgf: WguiPropertiesDialogFactoryP
        """
        super().__init__(scene, actions, clpbrd, pctx, pdgf)

        self.__scene = scene
        self.__prjContext = pctx