# ----------------------------------------------------------------------------
# - wmegui-props-dialog-factory                                              -
# - wild cruncher - cockpit: properties dialog box factory                   -
# ----------------------------------------------------------------------------
# - author    (c) 2016-2016 philippe lambert                                 -
# - copyright (c) 2016-2016 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wmegui_props_dialog_factory
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher properties dialog box factory

.. moduleauthor:: Philippe Lambert <lambert@silkan.com>
"""

from wcr_frontend.gui.wgui_props_dialog_factory import \
    WguiPropertiesDialogFactory
from wcr_frontend.modules.message.gui.wmegui_wgtbxmessage_instance_props_dialog \
    import WmeguiWgtBxMessageInstancePropertiesDialog
from wcr_core.modules.message.db.wmehdb_standard_operators import \
    WMEHDB_WBMESSAGE

WMEHDB_STD_OPERINST_PROPDLG = {WMEHDB_WBMESSAGE:
                                   WmeguiWgtBxMessageInstancePropertiesDialog}


class WmeguiPropertiesDialogFactory(WguiPropertiesDialogFactory):
    def __init__(self, prjContext, config, scene, actions, parent=None):
        """
        :param prjContext: Project context
        :type prjContext: WcorProjectContextP
        :param config: Project editor configuration
        :type config: WguiProjectEditorCfgP
        :param scene: Graphic scene adapter
        :type scene: WguiSceneAdapterP
        :param actions: GUI actions
        :type actions: dict[str, WactActionP]
        :param parent: Parent widget
        """
        super().__init__(prjContext, config, scene, actions, parent)

    def _createOperatorInstancePropertiesDialog(self, inst, pctx, updateF,
                                                selectXpnt, parent):
        propDlg = WMEHDB_STD_OPERINST_PROPDLG.get(inst.getOperator())
        if propDlg is not None:
            return propDlg(inst, pctx, updateF, selectXpnt, parent)
        else:
            return super()._createOperatorInstancePropertiesDialog(
                inst, pctx, updateF, selectXpnt, parent)