# ----------------------------------------------------------------------------
# - wfgui-project-actions                                                    -
# - wild cruncher - project editor actions                                   -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfgui_project_actions
   :platform:     Unix, Darwin, Windows
   :synopsis:     Wild Cruncher project editor actions

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""

from wcr_frontend.gui.wgui_project_actions import WguiEditorActionBase
from wcr_core.modules.statemachine.wfmod_application_module import \
    WFMOD_STATEMACHINE_APP_CODE


# noinspection PyAbstractClass
class WfguiEditorActionBase(WguiEditorActionBase):
    def __init__(self, name, description, *parameters):
        """
        :param name: Action name
        :type name: str
        :param description: Action description
        :type description: str
        :param parameters: Action parameter descriptions
        :type parameters: list[WactActionParameterP]
        """
        super().__init__(name, description, *parameters)

    def isEnabled(self, actx):
        if not super().isEnabled(actx):
            return False
        editor = actx.getEditor()
        """:type: WguiProjectEditor"""
        cctx = editor.cockpitSystemContext
        return cctx.code == WFMOD_STATEMACHINE_APP_CODE
