# ----------------------------------------------------------------------------
# - wfgui-props-dialog-widgets                                               -
# - wild cruncher - cockpit: general property dialog widgets                 -
# ----------------------------------------------------------------------------
# - author    (c) 2014-2014 clemens oertel                                   -
# - copyright (c) 2014-2014 silkan / wild systems                            -
# ----------------------------------------------------------------------------

"""
.. module::       wfgui_props_dialog_widgets
   :platform:     Unix, Windows
   :synopsis:     Wild Cruncher state machine general property dialog widgets

.. moduleauthor:: Clemens Oertel <clemens.oertel@silkan.com>
"""
from PyQt4.QtGui import QVBoxLayout, QTextEdit

from wcr_frontend.gui.wgui_props_dialog_widget import WguiPropertiesWidgetP


class WfguiExecutionProperties(WguiPropertiesWidgetP):
    """
    Configuration widget for a execution data.
    """

    def __init__(self, parent=None):
        """
        :param parent: Parent widget
        """
        super().__init__(parent)

        self.__execsF = QTextEdit()
        self.__execsF.setEnabled(False)

        self.setLayout(self._createLayout())
        self.updateFields()

    def _createLayout(self):
        layout = QVBoxLayout()
        layout.addWidget(self.__execsF)
        return layout

    def updateFields(self):
        # execs = self._getExecutables()
        #self.__execsF.setPlainText(execs)
        pass

    def save(self):
        # self._setExecutables(self.__execsF.toPlainText())
        pass

    def _getExecutables(self):
        """
        Get the current executables to display.

        :return: Current executables
        :rtype: str
        """
        raise NotImplementedError()

    def _setExecutables(self, execs):
        """
        Set the executables.

        :param execs: Executables
        :type execs: str
        """
        raise NotImplementedError()
